"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/* eslint-disable global-require */
var runtimeManager_1 = require("../core/runtimeManager");
var engineManager_1 = require("../core/engineManager");
var migrator_1 = require("../core/projectManager/migrator");
var projectManager_1 = require("../core/projectManager");
var integrationManager_1 = require("../core/integrationManager");
var taskManager_1 = require("../core/taskManager");
var engine_core_1 = (0, tslib_1.__importDefault)(require("../engine-core"));
var IGNORE_MISSING_ENGINES_TASKS = ['link', 'unlink'];
var run = function (c) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var result, taskInstance;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, (0, engineManager_1.registerEngine)(c, engine_core_1.default)];
            case 1:
                _a.sent();
                return [4 /*yield*/, (0, runtimeManager_1.configureRuntimeDefaults)(c)];
            case 2:
                _a.sent();
                return [4 /*yield*/, (0, migrator_1.checkAndMigrateProject)(c)];
            case 3:
                _a.sent();
                return [4 /*yield*/, (0, runtimeManager_1.updateRenativeConfigs)(c)];
            case 4:
                _a.sent();
                return [4 /*yield*/, (0, projectManager_1.checkAndBootstrapIfRequired)(c)];
            case 5:
                _a.sent();
                if (c.program.npxMode) {
                    return [2 /*return*/];
                }
                return [4 /*yield*/, (0, integrationManager_1.loadIntegrations)(c)];
            case 6:
                _a.sent();
                return [4 /*yield*/, (0, engineManager_1.loadEngines)(c)];
            case 7:
                result = _a.sent();
                if (!!result) return [3 /*break*/, 9];
                return [4 /*yield*/, (0, runtimeManager_1.updateRenativeConfigs)(c)];
            case 8:
                _a.sent();
                _a.label = 9;
            case 9:
                if (!(!c.command && c.paths.project.configExists)) return [3 /*break*/, 11];
                return [4 /*yield*/, (0, engineManager_1.registerMissingPlatformEngines)(c)];
            case 10:
                _a.sent();
                _a.label = 11;
            case 11: return [4 /*yield*/, (0, taskManager_1.findSuitableTask)(c)];
            case 12:
                taskInstance = _a.sent();
                if (!(c.command && !IGNORE_MISSING_ENGINES_TASKS.includes(c.command))) return [3 /*break*/, 14];
                return [4 /*yield*/, (0, engineManager_1.registerMissingPlatformEngines)(c, taskInstance)];
            case 13:
                _a.sent();
                _a.label = 14;
            case 14: 
            // Skip babel.config creation until template check
            // await checkAndCreateBabelConfig(c);
            return [4 /*yield*/, (0, taskManager_1.initializeTask)(c, taskInstance.task)];
            case 15:
                // Skip babel.config creation until template check
                // await checkAndCreateBabelConfig(c);
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
exports.default = run;
//# sourceMappingURL=index.js.map