"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withRNVMetro = exports.withRNVBabel = exports.withDefaultRNVBabel = void 0;
var tslib_1 = require("tslib");
var fs_1 = (0, tslib_1.__importDefault)(require("fs"));
var logger_1 = require("../systemManager/logger");
var withDefaultRNVBabel = function (cnf) { return ((0, tslib_1.__assign)({ retainLines: true, presets: [['@babel/preset-env', {}]], plugins: [
        [
            require.resolve('babel-plugin-module-resolver'),
            {
                root: [process.env.RNV_MONO_ROOT || '.'],
            },
        ],
    ] }, cnf)); };
exports.withDefaultRNVBabel = withDefaultRNVBabel;
var withRNVBabel = function (cnf) { return function (api) {
    if (!fs_1.default.existsSync(process.env.RNV_ENGINE_PATH)) {
        (0, logger_1.logInfo)("Path to engine cannot be resolved: ".concat(process.env.RNV_ENGINE_PATH, ". Will use default one"));
        api.cache(false);
        return (0, exports.withDefaultRNVBabel)(cnf);
    }
    var engine = require(process.env.RNV_ENGINE_PATH); // eslint-disable-line import/no-dynamic-require, global-require
    api.cache(true);
    if (engine.withRNVBabel) {
        return engine.withRNVBabel(cnf);
    }
    return cnf;
}; };
exports.withRNVBabel = withRNVBabel;
var withRNVMetro = function (cnf) {
    var engine = require(process.env.RNV_ENGINE_PATH); // eslint-disable-line import/no-dynamic-require, global-require
    if (engine.withRNV) {
        return engine.withRNV(cnf);
    }
    return cnf;
};
exports.withRNVMetro = withRNVMetro;
//# sourceMappingURL=index.js.map