"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.registerIntegration = exports.loadIntegrations = void 0;
var tslib_1 = require("tslib");
/* eslint-disable global-require, import/no-dynamic-require */
var path_1 = (0, tslib_1.__importDefault)(require("path"));
var fileutils_1 = require("../systemManager/fileutils");
// import { getScopedVersion } from '../systemManager/utils';
var logger_1 = require("../systemManager/logger");
var taskManager_1 = require("../taskManager");
var loadIntegrations = function (c) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var integrations;
    var _a;
    return (0, tslib_1.__generator)(this, function (_b) {
        (0, logger_1.logTask)('loadIntegrations');
        integrations = (_a = c.buildConfig) === null || _a === void 0 ? void 0 : _a.integrations;
        if (integrations) {
            Object.keys(integrations).forEach(function (integration) {
                // const ver = getScopedVersion(c, k, integrations[k], 'integrationTemplates');
                var _a;
                // Local node modules take precedence
                var intPath = path_1.default.join(c.paths.project.nodeModulesDir, integration);
                if (!(0, fileutils_1.fsExistsSync)(intPath)) {
                    intPath = integration;
                }
                try {
                    var instance = (_a = require(intPath)) === null || _a === void 0 ? void 0 : _a.default;
                    if (instance) {
                        instance.getTasks().forEach(function (task) {
                            (0, taskManager_1.registerCustomTask)(c, task);
                        });
                    }
                }
                catch (err) {
                    (0, logger_1.logWarning)("You have integration ".concat(integration, " defined, but it wasn't found in package.json. ERR: ").concat(err));
                }
            });
        }
        return [2 /*return*/];
    });
}); };
exports.loadIntegrations = loadIntegrations;
var registerIntegration = function () {
};
exports.registerIntegration = registerIntegration;
//# sourceMappingURL=index.js.map