"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.configureRuntimeDefaults = exports.updateRenativeConfigs = void 0;
var tslib_1 = require("tslib");
var constants_1 = require("../constants");
var engineManager_1 = require("../engineManager");
var utils_1 = require("../systemManager/utils");
var fileutils_1 = require("../systemManager/fileutils");
var common_1 = require("../common");
var logger_1 = require("../systemManager/logger");
var pluginManager_1 = require("../pluginManager");
var index_1 = require("../configManager/index");
var updateRenativeConfigs = function (c) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, (0, pluginManager_1.loadPluginTemplates)(c)];
            case 1:
                _a.sent();
                return [4 /*yield*/, (0, index_1.parseRenativeConfigs)(c)];
            case 2:
                _a.sent();
                return [2 /*return*/, true];
        }
    });
}); };
exports.updateRenativeConfigs = updateRenativeConfigs;
var configureRuntimeDefaults = function (c) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var defaultHost, portString, portOffset, hosted;
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r;
    return (0, tslib_1.__generator)(this, function (_s) {
        c.runtime.appId = ((_c = (_b = (_a = c.files.project) === null || _a === void 0 ? void 0 : _a.configLocal) === null || _b === void 0 ? void 0 : _b._meta) === null || _c === void 0 ? void 0 : _c.currentAppConfigId) || null;
        // c.runtime.appConfigDir = c.files.project?.configLocal?._meta?.currentAppConfigDir || null;
        (0, logger_1.logTask)('configureRuntimeDefaults', "appId:".concat(c.runtime.appId));
        // TODO:
        // version
        // title
        c.runtime.currentEngine = (_d = c.runtime.enginesByPlatform) === null || _d === void 0 ? void 0 : _d[c.platform];
        c.runtime.currentPlatform = (_f = (_e = c.runtime.currentEngine) === null || _e === void 0 ? void 0 : _e.platforms) === null || _f === void 0 ? void 0 : _f[c.platform];
        defaultHost = utils_1.isSystemWin ? '127.0.0.1' : '0.0.0.0';
        portString = c.program.port
            || ((_j = (_h = (_g = c.buildConfig) === null || _g === void 0 ? void 0 : _g.defaults) === null || _h === void 0 ? void 0 : _h.ports) === null || _j === void 0 ? void 0 : _j[c.platform])
            || ((_k = c.runtime.currentPlatform) === null || _k === void 0 ? void 0 : _k.defaultPort);
        portOffset = ((_m = (_l = c.buildConfig) === null || _l === void 0 ? void 0 : _l.defaults) === null || _m === void 0 ? void 0 : _m.portOffset) || 0;
        c.runtime.port = (Number(portString) + portOffset).toString();
        if (c.program.target !== true) {
            c.runtime.target = c.program.target
                || ((_p = (_o = c.buildConfig) === null || _o === void 0 ? void 0 : _o.defaultTargets) === null || _p === void 0 ? void 0 : _p[c.platform]);
        }
        else
            c.runtime.target = c.program.target;
        c.runtime.scheme = c.program.scheme || 'debug';
        c.runtime.localhost = c.program.hostIp || defaultHost;
        c.runtime.timestamp = c.runtime.timestamp || Date.now();
        c.configPropsInjects = c.configPropsInjects || [];
        c.systemPropsInjects = c.systemPropsInjects || [];
        c.runtimePropsInjects = [];
        constants_1.INJECTABLE_RUNTIME_PROPS.forEach(function (key) {
            c.runtimePropsInjects.push({
                pattern: "{{runtimeProps.".concat(key, "}}"),
                override: c.runtime[key]
            });
        });
        if (c.buildConfig) {
            c.runtime.bundleAssets = (0, common_1.getConfigProp)(c, c.platform, 'bundleAssets', false);
            hosted = c.program.hosted;
            c.runtime.hosted = (hosted || !c.runtime.scheme.bundleAssets) && ((_q = c.runtime.currentPlatform) === null || _q === void 0 ? void 0 : _q.isWebHosted);
            // c.runtime.devServer = `http://${ip.address()}:${c.runtime.port}`;
            if ((_r = c.buildConfig.defaults) === null || _r === void 0 ? void 0 : _r.supportedPlatforms) {
                c.runtime.supportedPlatforms = c.buildConfig.defaults.supportedPlatforms.map(function (platform) {
                    var _a, _b, _c, _d;
                    var engine = (0, engineManager_1.getEngineRunnerByPlatform)(c, platform);
                    if (engine) {
                        var dir = engine.originalTemplatePlatformsDir;
                        var isConnected = false;
                        var isValid = false;
                        var pDir = (_a = c.paths.project.platformTemplatesDirs) === null || _a === void 0 ? void 0 : _a[platform];
                        if (pDir) {
                            isValid = true;
                            isConnected = (_b = pDir === null || pDir === void 0 ? void 0 : pDir.includes) === null || _b === void 0 ? void 0 : _b.call(pDir, (0, fileutils_1.getRealPath)(c, dir));
                        }
                        var port = ((_c = c.buildConfig.defaults) === null || _c === void 0 ? void 0 : _c[platform]) || ((_d = c.runtime.currentPlatform) === null || _d === void 0 ? void 0 : _d.defaultPort);
                        return {
                            engine: engine,
                            platform: platform,
                            isConnected: isConnected,
                            port: port,
                            isValid: isValid
                        };
                    }
                    return null;
                }).filter(function (v) { return v; });
            }
        }
        return [2 /*return*/, true];
    });
}); };
exports.configureRuntimeDefaults = configureRuntimeDefaults;
//# sourceMappingURL=index.js.map