"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateRuntimeObjectSchema = exports.getRuntimeObjectSchema = exports.validateRenativeJsonSchema = exports.getRenativeJsonSchema = void 0;
var tslib_1 = require("tslib");
var ajv_1 = (0, tslib_1.__importDefault)(require("ajv"));
var schemaRenativeJson_1 = require("./schemaRenativeJson");
var schemaRuntimeObject_1 = require("./schemaRuntimeObject");
var ajvRenativeJson = new ajv_1.default({ schemas: schemaRenativeJson_1.SCHEMAS_RENATIVE_JSON, allErrors: true, allowUnionTypes: true });
var ajvRuntimeObject = new ajv_1.default({ schemas: schemaRuntimeObject_1.SCHEMAS_RUNTIME_OBJECT, allErrors: true, allowUnionTypes: true });
var getRenativeJsonSchema = function () { return schemaRenativeJson_1.SCHEMAS_RENATIVE_JSON[0]; };
exports.getRenativeJsonSchema = getRenativeJsonSchema;
var validateRenativeJsonSchema = function (cObj) {
    var valid = ajvRenativeJson.validate(schemaRenativeJson_1.SCHEMAS_RENATIVE_JSON[0], cObj);
    return [valid, ajvRenativeJson];
};
exports.validateRenativeJsonSchema = validateRenativeJsonSchema;
var getRuntimeObjectSchema = function () { return schemaRuntimeObject_1.SCHEMAS_RUNTIME_OBJECT[0]; };
exports.getRuntimeObjectSchema = getRuntimeObjectSchema;
var validateRuntimeObjectSchema = function (cObj) {
    var valid = ajvRuntimeObject.validate(schemaRuntimeObject_1.SCHEMAS_RUNTIME_OBJECT[0], cObj);
    return [valid, ajvRuntimeObject];
};
exports.validateRuntimeObjectSchema = validateRuntimeObjectSchema;
//# sourceMappingURL=index.js.map