"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.waitForEmulator = void 0;
var tslib_1 = require("tslib");
var ora_1 = (0, tslib_1.__importDefault)(require("../../../cli/ora"));
var exec_1 = require("../../systemManager/exec");
var waitForEmulator = function (c, cli, command, callback) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var attempts, maxAttempts, CHECK_INTEVAL, maxErrorLength, spinner;
    return (0, tslib_1.__generator)(this, function (_a) {
        attempts = 0;
        maxAttempts = 30;
        CHECK_INTEVAL = 2000;
        maxErrorLength = c.program.maxErrorLength;
        spinner = (0, ora_1.default)('Waiting for emulator to boot...').start();
        return [2 /*return*/, new Promise(function (resolve, reject) {
                var interval = setInterval(function () {
                    (0, exec_1.execCLI)(c, cli, command, {
                        silent: true,
                        timeout: 10000,
                        maxErrorLength: maxErrorLength
                    })
                        .then(function (resp) {
                        if (callback(resp)) {
                            clearInterval(interval);
                            spinner.succeed();
                            return resolve(true);
                        }
                        attempts++;
                        if (attempts === maxAttempts) {
                            clearInterval(interval);
                            spinner.fail("Can't connect to the running emulator. Try restarting it.");
                            return reject("Can't connect to the running emulator. Try restarting it.");
                        }
                    })
                        .catch(function () {
                        attempts++;
                        if (attempts > maxAttempts) {
                            clearInterval(interval);
                            spinner.fail("Can't connect to the running emulator. Try restarting it.");
                            return reject("Can't connect to the running emulator. Try restarting it.");
                        }
                    });
                }, CHECK_INTEVAL);
            })];
    });
}); };
exports.waitForEmulator = waitForEmulator;
//# sourceMappingURL=common.js.map