"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.launchKaiOSSimulator = void 0;
var tslib_1 = require("tslib");
var path_1 = (0, tslib_1.__importDefault)(require("path"));
var fileutils_1 = require("../../systemManager/fileutils");
var logger_1 = require("../../systemManager/logger");
var constants_1 = require("../../constants");
var childProcess = require('child_process');
var launchKaiOSSimulator = function (c) { return new Promise(function (resolve, reject) {
    var _a, _b, _c, _d;
    (0, logger_1.logTask)('launchKaiOSSimulator');
    if (!((_b = (_a = c.buildConfig) === null || _a === void 0 ? void 0 : _a.sdks) === null || _b === void 0 ? void 0 : _b.KAIOS_SDK)) {
        reject("".concat(constants_1.KAIOS_SDK, " is not configured in your ").concat(c.paths.workspace.config, " file. Make sure you add location to your Kaiosrt App path similar to: ").concat((0, logger_1.chalk)().white.bold('"KAIOS_SDK": "/Applications/Kaiosrt.app"')));
        return;
    }
    var ePath = (0, fileutils_1.getRealPath)(path_1.default.join((_d = (_c = c.buildConfig) === null || _c === void 0 ? void 0 : _c.sdks) === null || _d === void 0 ? void 0 : _d.KAIOS_SDK));
    if (!(0, fileutils_1.fsExistsSync)(ePath)) {
        reject("Can't find emulator at path: ".concat(ePath));
        return;
    }
    childProcess.exec("open ".concat(ePath), function (err) {
        if (err) {
            reject(err);
            return;
        }
        resolve();
    });
}); };
exports.launchKaiOSSimulator = launchKaiOSSimulator;
//# sourceMappingURL=kaios.js.map