"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.replaceHomeFolder = void 0;
var utils_1 = require("../systemManager/utils");
var androidPlatform = 'linux';
var tizenPlatform = 'ubuntu';
var tizenExtension = 'bin';
if (utils_1.isSystemWin) {
    androidPlatform = 'windows';
    tizenPlatform = 'windows';
    tizenExtension = 'exe';
}
if (process.platform === 'darwin') {
    tizenPlatform = 'macos';
    tizenExtension = 'dmg';
}
var replaceHomeFolder = function (p) {
    if (utils_1.isSystemWin)
        return p.replace('~', process.env.USERPROFILE);
    return p.replace('~', process.env.HOME);
};
exports.replaceHomeFolder = replaceHomeFolder;
exports.default = {
    android: {
        sdkUrl: "https://dl.google.com/android/repository/sdk-tools-".concat(androidPlatform, "-4333796.zip"),
        downloadLocation: (0, exports.replaceHomeFolder)("~/sdk-tools-".concat(androidPlatform, "-4333796.zip")),
        location: (0, exports.replaceHomeFolder)('~/Android')
    },
    tizen: {
        sdkUrl: "http://download.tizen.org/sdk/Installer/tizen-studio_3.3/web-ide_Tizen_Studio_3.3_".concat(tizenPlatform, "-64.").concat(tizenExtension),
        downloadLocation: (0, exports.replaceHomeFolder)("~/web-ide_Tizen_Studio_3.3_".concat(tizenPlatform, "-64.").concat(tizenExtension))
    },
    webos: {
        downloadLink: 'http://webostv.developer.lge.com/sdk/installation/#'
    }
};
//# sourceMappingURL=config.js.map