"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var exec_1 = require("../systemManager/exec");
var base_1 = (0, tslib_1.__importDefault)(require("./base"));
var config_1 = (0, tslib_1.__importDefault)(require("../configManager/config"));
var LinuxPlatformSetup = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(LinuxPlatformSetup, _super);
    function LinuxPlatformSetup() {
        return _super.call(this, 'darwin') || this;
    }
    LinuxPlatformSetup.prototype.installFastlane = function () {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            var c;
            return (0, tslib_1.__generator)(this, function (_a) {
                c = config_1.default.getConfig();
                if ((0, exec_1.commandExistsSync)('brew')) {
                    return [2 /*return*/, (0, exec_1.executeAsync)(c, 'brew cask install fastlane', {
                            interactive: true
                        })];
                }
                return [2 /*return*/, (0, exec_1.executeAsync)(c, 'sudo gem install fastlane -NV', {
                        interactive: true
                    })];
            });
        });
    };
    LinuxPlatformSetup.prototype.installDocker = function () {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            return (0, tslib_1.__generator)(this, function (_a) {
                throw new Error('Automated Docker install is not supported on this platform. Please go to https://hub.docker.com/editions/community/docker-ce-desktop-mac and install it manually. Then rerun this command');
            });
        });
    };
    return LinuxPlatformSetup;
}(base_1.default));
exports.default = LinuxPlatformSetup;
//# sourceMappingURL=darwin.js.map