"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var linux_1 = (0, tslib_1.__importDefault)(require("./linux"));
var windows_1 = (0, tslib_1.__importDefault)(require("./windows"));
var darwin_1 = (0, tslib_1.__importDefault)(require("./darwin"));
var config_1 = (0, tslib_1.__importDefault)(require("../configManager/config"));
exports.default = (function (_c) {
    var c = _c;
    if (!c)
        c = config_1.default.getConfig();
    var platform = c.process.platform;
    if (platform === 'linux')
        return new linux_1.default(c);
    if (platform === 'win32')
        return new windows_1.default(c);
    if (platform === 'darwin')
        return new darwin_1.default();
    // @todo add support for more
    throw new Error('Platform unsupported for automated SDK setup');
});
//# sourceMappingURL=index.js.map