export function parseErrorMessage(text: any, maxErrorLength?: number): any;
declare namespace _default {
    export { executeAsync };
    export { execCLI };
    export { openCommand };
    export { executeTelnet };
    export { commandExistsSync };
}
export default _default;
/**
 *
 * Also accepts the Node's child_process exec/spawn options
 */
export type Opts = {
    /**
     * - private params that will be masked in the logs
     */
    privateParams: Object;
    /**
     * - don't print anything
     */
    silent: boolean;
    /**
     * - will print the loader but it will finish with a
     * checkmark regardless of the outcome. Also, it never throws a catch.
     */
    ignoreErrors: boolean;
    /**
     * - when you want to execute a command that requires user input
     *
     * Execute commands
     */
    interactive: boolean;
};
/**
 *
 * Execute a plain command
 *
 * @param {String} command - the command to be executed
 * @param {Opts} [opts={}] - the options for the command
 * @returns {Promise}
 *
 */
export function executeAsync(_c: any, _cmd: any, _opts: any): Promise<any>;
/**
 *
 * Execute CLI command
 *
 * @param {Object} c - the trusty old c object
 * @param {String} cli - the cli to be executed
 * @param {String} command - the command to be executed
 * @param {Opts} [opts={}] - the options for the command
 * @returns {Promise}
 *
 */
export function execCLI(c: Object, cli: string, command: string, opts?: Opts | undefined): Promise<any>;
export function commandExists(commandName: any, callback: any): Promise<any> | undefined;
export function commandExistsSync(commandName: any): boolean;
export const openCommand: "start" | "open" | "xdg-open";
/**
 *
 * Connect to a local telnet server and execute a command
 *
 * @param {Number|String} port - where do you want me to connect to?
 * @param {String} command - the command to be executed once I'm connected
 * @returns {Promise}
 *
 */
export function executeTelnet(c: any, port: number | string, command: string): Promise<any>;
//# sourceMappingURL=exec.d.ts.map