"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.configureGit = void 0;
var tslib_1 = require("tslib");
var path_1 = (0, tslib_1.__importDefault)(require("path"));
var exec_1 = require("./exec");
var fileutils_1 = require("./fileutils");
var logger_1 = require("./logger");
var configureGit = function (c) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var projectPath;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                projectPath = c.paths.project.dir;
                (0, logger_1.logTask)("configureGit:".concat(projectPath));
                if (!!(0, fileutils_1.fsExistsSync)(path_1.default.join(projectPath, '.git'))) return [3 /*break*/, 5];
                (0, logger_1.logInfo)('Your project does not have a git repo. Creating one...DONE');
                if (!(0, exec_1.commandExistsSync)('git')) return [3 /*break*/, 4];
                return [4 /*yield*/, (0, exec_1.executeAsync)('git init', { cwd: projectPath })];
            case 1:
                _a.sent();
                return [4 /*yield*/, (0, exec_1.executeAsync)('git add -A', { cwd: projectPath })];
            case 2:
                _a.sent();
                return [4 /*yield*/, (0, exec_1.executeAsync)('git commit -m "Initial"', { cwd: projectPath })];
            case 3:
                _a.sent();
                return [3 /*break*/, 5];
            case 4:
                (0, logger_1.logWarning)("We tried to create a git repo inside your project but you don't seem to have git installed");
                _a.label = 5;
            case 5: return [2 /*return*/];
        }
    });
}); };
exports.configureGit = configureGit;
//# sourceMappingURL=gitUtils.js.map