"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.printBoxEnd = exports.printBoxStart = exports.printArrIntoBox = exports.printIntoBox = exports.logAppInfo = exports.logInitialize = exports.logEnd = exports.logError = exports.logSuccess = exports.logComplete = exports.isInfoEnabled = exports.logDebug = exports.logInfo = exports.logWarning = exports.logHook = exports.logExitTask = exports.logInitTask = exports.logTask = exports.logSummary = exports.logRaw = exports.logToSummary = exports.getCurrentCommand = exports.logAndSave = exports.logWelcome = exports.chalk = exports.stripAnsi = void 0;
var tslib_1 = require("tslib");
/* eslint-disable no-console */
var chalk_1 = (0, tslib_1.__importDefault)(require("chalk"));
var utils_1 = require("./utils");
function ansiRegex(_a) {
    var _b = _a === void 0 ? {} : _a, _d = _b.onlyFirst, onlyFirst = _d === void 0 ? false : _d;
    var pattern = [
        '[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)',
        '(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))'
    ].join('|');
    return new RegExp(pattern, onlyFirst ? undefined : 'g');
}
function stripAnsi(string) {
    if (typeof string !== 'string') {
        throw new TypeError("Expected a `string`, got `".concat(typeof string, "`"));
    }
    return string.replace(ansiRegex(), '');
}
exports.stripAnsi = stripAnsi;
var ICN_ROCKET = utils_1.isSystemWin ? 'RNV' : '🚀';
var ICN_UNICORN = utils_1.isSystemWin ? 'unicorn' : '🦄';
var _chalkCols = {
    white: function (v) { return v; },
    green: function (v) { return v; },
    red: function (v) { return v; },
    yellow: function (v) { return v; },
    default: function (v) { return v; },
    gray: function (v) { return v; },
    grey: function (v) { return v; },
    blue: function (v) { return v; },
    cyan: function (v) { return v; },
    magenta: function (v) { return v; }
};
_chalkCols.rgb = function () { return function (v) { return v; }; };
_chalkCols.bold = _chalkCols;
var _chalkMono = (0, tslib_1.__assign)({}, _chalkCols);
var currentChalk = chalk_1.default;
var RNV = 'ReNative';
var chalk = function () { return currentChalk || chalk_1.default; };
exports.chalk = chalk;
var logWelcome = function () {
    var _a, _b, _d, _e, _f;
    // prettier-ignore
    var str = _defaultColor("\n\u250C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2510\n\u2502                                                                              \u2502\n\u2502        ".concat(currentChalk.red('██████╗'), " \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557").concat(currentChalk.red('███╗   ██╗'), " \u2588\u2588\u2588\u2588\u2588\u2557 \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557\u2588\u2588\u2557").concat(currentChalk.red('██╗   ██╗'), "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557       \u2502\n\u2502        ").concat(currentChalk.red('██╔══██╗'), "\u2588\u2588\u2554\u2550\u2550\u2550\u2550\u255D").concat(currentChalk.red('████╗  ██║'), "\u2588\u2588\u2554\u2550\u2550\u2588\u2588\u2557\u255A\u2550\u2550\u2588\u2588\u2554\u2550\u2550\u255D\u2588\u2588\u2551").concat(currentChalk.red('██║   ██║'), "\u2588\u2588\u2554\u2550\u2550\u2550\u2550\u255D       \u2502\n\u2502        ").concat(currentChalk.red('██████╔╝'), "\u2588\u2588\u2588\u2588\u2588\u2557  ").concat(currentChalk.red('██╔██╗ ██║'), "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2551   \u2588\u2588\u2551   \u2588\u2588\u2551").concat(currentChalk.red('██║   ██║'), "\u2588\u2588\u2588\u2588\u2588\u2557         \u2502\n\u2502        ").concat(currentChalk.red('██╔══██╗'), "\u2588\u2588\u2554\u2550\u2550\u255D  ").concat(currentChalk.red('██║╚██╗██║'), "\u2588\u2588\u2554\u2550\u2550\u2588\u2588\u2551   \u2588\u2588\u2551   \u2588\u2588\u2551").concat(currentChalk.red('╚██╗ ██╔╝'), "\u2588\u2588\u2554\u2550\u2550\u255D         \u2502\n\u2502        ").concat(currentChalk.red('██║  ██║'), "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557").concat(currentChalk.red('██║ ╚████║'), "\u2588\u2588\u2551  \u2588\u2588\u2551   \u2588\u2588\u2551   \u2588\u2588\u2551").concat(currentChalk.red(' ╚████╔╝ '), "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557       \u2502\n\u2502        ").concat(currentChalk.red('╚═╝  ╚═╝'), "\u255A\u2550\u2550\u2550\u2550\u2550\u2550\u255D").concat(currentChalk.red('╚═╝  ╚═══╝'), "\u255A\u2550\u255D  \u255A\u2550\u255D   \u255A\u2550\u255D   \u255A\u2550\u255D").concat(currentChalk.red('  ╚═══╝  '), "\u255A\u2550\u2550\u2550\u2550\u2550\u2550\u255D       \u2502\n\u2502                                                                              \u2502\n"));
    if ((_d = (_b = (_a = cnf().files) === null || _a === void 0 ? void 0 : _a.rnv) === null || _b === void 0 ? void 0 : _b.package) === null || _d === void 0 ? void 0 : _d.version) {
        cnf().rnvVersion = cnf().files.rnv.package.version;
        str += (0, exports.printIntoBox)("      Version: ".concat(currentChalk.green(cnf().rnvVersion)), 1);
        if ((_f = (_e = cnf().rnvVersion) === null || _e === void 0 ? void 0 : _e.includes) === null || _f === void 0 ? void 0 : _f.call(_e, 'alpha')) {
            str += (0, exports.printIntoBox)("      ".concat(currentChalk.yellow('WARNING: this is a prerelease version.')), 1);
        }
    }
    str += (0, exports.printIntoBox)("      ".concat(currentChalk.grey('https://renative.org')), 1);
    str += (0, exports.printIntoBox)("      ".concat(ICN_ROCKET, " ").concat(currentChalk.yellow('Firing up!...')), 1);
    str += (0, exports.printIntoBox)("      $ ".concat(currentChalk.cyan((0, exports.getCurrentCommand)(true))), 1);
    if (global.timeStart) {
        str += (0, exports.printIntoBox)("      Start Time: ".concat(currentChalk.grey(global.timeStart.toLocaleString())));
    }
    str += (0, exports.printIntoBox)('');
    str += (0, exports.printBoxEnd)();
    str += '\n';
    console.log(str);
};
exports.logWelcome = logWelcome;
var _currentProcess;
var _isInfoEnabled = false;
var _infoFilter = [];
var _c;
var _isMono = false;
var _defaultColor;
var _highlightColor;
var _analytics;
var _jsonOnly;
var cnf = function () {
    if (!_c) {
        _configureLogger(global.RNV_CONFIG, global.RNV_ANALYTICS);
    }
    return _c;
};
var _configureLogger = function (c, analytics) {
    var _a, _b;
    global._messages = [];
    _c = c;
    if (!global.timeStart)
        global.timeStart = new Date();
    _currentProcess = c.process;
    _isInfoEnabled = !!c.program.info;
    _jsonOnly = !!c.program.json;
    _infoFilter = (_b = (_a = c.program.info) === null || _a === void 0 ? void 0 : _a.split) === null || _b === void 0 ? void 0 : _b.call(_a, ',');
    _isMono = c.program.mono;
    _analytics = analytics;
    if (_isMono) {
        currentChalk = _chalkMono;
    }
    _updateDefaultColors();
    RNV = (0, exports.getCurrentCommand)();
};
var _updateDefaultColors = function () {
    _defaultColor = currentChalk.gray;
    _highlightColor = currentChalk.green;
};
_updateDefaultColors();
var logAndSave = function (msg, skipLog) {
    if (global._messages && !global._messages.includes(msg))
        global._messages.push(msg);
    if (!skipLog)
        console.log("".concat(msg));
};
exports.logAndSave = logAndSave;
var PRIVATE_PARAMS = ['-k', '--key'];
var _printJson = function (obj) {
    // sanitize
    if (obj.task) {
        obj.task = obj.task.trim().replace('[', '').replace(']', '');
    }
    console.log(JSON.stringify(obj));
};
var getCurrentCommand = function (excludeDollar) {
    if (excludeDollar === void 0) { excludeDollar = false; }
    var argArr = cnf().process.argv.slice(2);
    var hideNext = false;
    var output = argArr
        .map(function (v) {
        if (hideNext) {
            hideNext = false;
            return '********';
        }
        if (PRIVATE_PARAMS.includes(v)) {
            hideNext = true;
        }
        return v;
    })
        .join(' ');
    var dollar = excludeDollar ? '' : '$ ';
    return "".concat(dollar, "rnv ").concat(output);
};
exports.getCurrentCommand = getCurrentCommand;
var logToSummary = function (v, sanitizePaths) {
    var _v = sanitizePaths ? _sanitizePaths(v) : v;
    global._messages.push("\n".concat(_v));
};
exports.logToSummary = logToSummary;
var logRaw = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    console.log.apply(null, args);
};
exports.logRaw = logRaw;
var logSummary = function (header) {
    var _a, _b, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6;
    if (header === void 0) { header = 'SUMMARY'; }
    var logContent = (0, exports.printIntoBox)("All good as ".concat(ICN_UNICORN, " "));
    if (global._messages && global._messages.length) {
        logContent = '';
        global._messages.forEach(function (m) {
            logContent += "\u2502 ".concat(m, "\n");
        });
    }
    var timeString = '';
    global.timeEnd = new Date();
    timeString = "| ".concat(global.timeEnd.toLocaleString());
    var str = (0, exports.printBoxStart)("".concat(ICN_ROCKET, "  ").concat(header, " ").concat(timeString), (0, exports.getCurrentCommand)());
    str += (0, exports.printIntoBox)("ReNative Version: ".concat(_highlightColor(cnf().rnvVersion)), 1);
    if ((_b = (_a = cnf().files) === null || _a === void 0 ? void 0 : _a.project) === null || _b === void 0 ? void 0 : _b.package) {
        str += (0, exports.printIntoBox)("Project Name ($package.name): ".concat(_highlightColor(cnf().files.project.package.name)), 1);
        str += (0, exports.printIntoBox)("Project Version ($package.version): ".concat(_highlightColor(cnf().files.project.package.version)), 1);
    }
    if ((_d = cnf().buildConfig) === null || _d === void 0 ? void 0 : _d.workspaceID) {
        str += (0, exports.printIntoBox)("Workspace ($.workspaceID): ".concat(_highlightColor(cnf().buildConfig.workspaceID)), 1);
    }
    if (cnf().platform) {
        str += (0, exports.printIntoBox)("Platform (-p): ".concat(_highlightColor(cnf().platform)), 1);
    }
    if ((_e = cnf().runtime) === null || _e === void 0 ? void 0 : _e.engine) {
        var addon = '';
        if (cnf().platform) {
            addon = " ($.platforms.".concat(cnf().platform, ".engine)");
        }
        str += (0, exports.printIntoBox)("Engine".concat(addon, ": ").concat(_highlightColor((_h = (_g = (_f = cnf().runtime) === null || _f === void 0 ? void 0 : _f.engine) === null || _g === void 0 ? void 0 : _g.config) === null || _h === void 0 ? void 0 : _h.id)), 1);
    }
    if ((_j = cnf().runtime) === null || _j === void 0 ? void 0 : _j.activeTemplate) {
        str += (0, exports.printIntoBox)("Template: ".concat(_highlightColor((_k = cnf().runtime) === null || _k === void 0 ? void 0 : _k.activeTemplate)), 1);
    }
    if ((_m = (_l = cnf().buildConfig) === null || _l === void 0 ? void 0 : _l._meta) === null || _m === void 0 ? void 0 : _m.currentAppConfigId) {
        str += (0, exports.printIntoBox)("App Config (-c): ".concat(_highlightColor((_o = cnf().buildConfig._meta) === null || _o === void 0 ? void 0 : _o.currentAppConfigId)), 1);
    }
    if ((_p = cnf().runtime) === null || _p === void 0 ? void 0 : _p.scheme) {
        str += (0, exports.printIntoBox)("Build Scheme (-s): ".concat(_highlightColor((_q = cnf().runtime) === null || _q === void 0 ? void 0 : _q.scheme)), 1);
    }
    if ((_r = cnf().runtime) === null || _r === void 0 ? void 0 : _r.bundleAssets) {
        str += (0, exports.printIntoBox)("Bundle assets ($.platforms.".concat(cnf().platform, ".bundleAssets): ").concat(_highlightColor(!!((_s = cnf().runtime) === null || _s === void 0 ? void 0 : _s.bundleAssets))), 1);
    }
    if ((_t = cnf().runtime) === null || _t === void 0 ? void 0 : _t.target) {
        str += (0, exports.printIntoBox)("Target (-t): ".concat(_highlightColor((_u = cnf().runtime) === null || _u === void 0 ? void 0 : _u.target)), 1);
    }
    if ((_w = cnf().program) === null || _w === void 0 ? void 0 : _w.reset) {
        str += (0, exports.printIntoBox)("Reset Project (-r): ".concat(_highlightColor(!!((_x = cnf().program) === null || _x === void 0 ? void 0 : _x.reset))), 1);
    }
    if ((_y = cnf().program) === null || _y === void 0 ? void 0 : _y.resetHard) {
        str += (0, exports.printIntoBox)("Reset Project and Assets (-R): ".concat(_highlightColor(!!((_z = cnf().program) === null || _z === void 0 ? void 0 : _z.resetHard))), 1);
    }
    if ((_1 = (_0 = cnf().runtime) === null || _0 === void 0 ? void 0 : _0.supportedPlatforms) === null || _1 === void 0 ? void 0 : _1.length) {
        var plats = cnf().runtime.supportedPlatforms.map(function (v) { return "".concat(v.platform).concat(v.isConnected ? '' : '(ejected)'); });
        str += (0, exports.printArrIntoBox)(plats, 'Supported Platforms: ');
    }
    if ((_4 = (_3 = (_2 = cnf().files) === null || _2 === void 0 ? void 0 : _2.project) === null || _3 === void 0 ? void 0 : _3.config) === null || _4 === void 0 ? void 0 : _4.defaults) {
        var defaultProjectConfigs = cnf().files.project.config.defaults;
        if (defaultProjectConfigs === null || defaultProjectConfigs === void 0 ? void 0 : defaultProjectConfigs.template) {
            str += (0, exports.printIntoBox)("Master Template: ".concat(_highlightColor(defaultProjectConfigs.template)), 1);
        }
    }
    if (cnf().process) {
        var envString = "".concat(cnf().process.platform, " | ").concat(cnf().process.arch, " | node v").concat((_5 = cnf().process.versions) === null || _5 === void 0 ? void 0 : _5.node);
        str += (0, exports.printIntoBox)("Env Info: ".concat(currentChalk.gray(envString)), 1);
    }
    if (global.timeEnd) {
        str += (0, exports.printIntoBox)("Executed Time: ".concat(currentChalk.yellow(_msToTime(global.timeEnd - global.timeStart))), 1);
    }
    str += (0, exports.printIntoBox)('');
    str += logContent.replace(/\n\s*\n\s*\n/g, '\n\n');
    str += (0, exports.printIntoBox)('');
    if ((_6 = cnf().runtime) === null || _6 === void 0 ? void 0 : _6.platformBuildsProjectPath) {
        str += (0, exports.printIntoBox)('Project location:');
        str += (0, exports.printIntoBox)("".concat(currentChalk.cyan(_sanitizePaths(cnf().runtime.platformBuildsProjectPath))), 1);
    }
    str += (0, exports.printBoxEnd)();
    console.log(str);
};
exports.logSummary = logSummary;
var _msToTime = function (seconds) {
    var s = seconds;
    var ms = s % 1000;
    s = (s - ms) / 1000;
    var secs = s % 60;
    s = (s - secs) / 60;
    var mins = s % 60;
    var hrs = (s - mins) / 60;
    return "".concat(hrs, "h:").concat(mins, "m:").concat(secs, "s:").concat(ms, "ms");
};
var _getCurrentTask = function () { return (cnf()._currentTask ? currentChalk.grey(" [".concat(cnf()._currentTask, "]")) : ''); };
var _sanitizePaths = function (msg) {
    var _a, _b;
    // let dir
    // const config = cnf().files?.project?.config;
    // if(config && config.isMonorepo) {
    //     if()
    // }
    if ((msg === null || msg === void 0 ? void 0 : msg.replace) && ((_b = (_a = cnf().paths) === null || _a === void 0 ? void 0 : _a.project) === null || _b === void 0 ? void 0 : _b.dir)) {
        return msg.replace(new RegExp(cnf().paths.project.dir, 'g'), '.');
    }
    return msg;
};
var TASK_COUNTER = {};
var logTask = function (task, customChalk) {
    if (!TASK_COUNTER[task])
        TASK_COUNTER[task] = 0;
    TASK_COUNTER[task] += 1;
    var taskCount = currentChalk.grey("[".concat(TASK_COUNTER[task], "]"));
    if (_jsonOnly) {
        return _printJson({ type: 'task', task: stripAnsi(_getCurrentTask()), message: stripAnsi(_sanitizePaths(typeof customChalk === 'string' ? customChalk : task)) });
    }
    var msg = '';
    if (typeof customChalk === 'string') {
        msg = "".concat(currentChalk.green("[ task ]".concat(_getCurrentTask(), " ").concat(task))).concat(taskCount, " ").concat(currentChalk.grey(customChalk));
    }
    else if (customChalk) {
        msg = customChalk("[ task ]".concat(_getCurrentTask(), " ").concat(task).concat(taskCount));
    }
    else {
        msg = currentChalk.green("[ task ]".concat(_getCurrentTask(), " ").concat(task).concat(taskCount));
    }
    console.log(_sanitizePaths(msg));
};
exports.logTask = logTask;
var logInitTask = function (task, customChalk) {
    if (_jsonOnly) {
        return _printJson({ type: 'taskInit', task: stripAnsi(_getCurrentTask()), message: stripAnsi(_sanitizePaths(typeof customChalk === 'string' ? customChalk : task)) });
    }
    var msg = '';
    if (typeof customChalk === 'string') {
        msg = "".concat(currentChalk.rgb(183, 84, 117)("[ task ] ".concat(task)), " ").concat(currentChalk.grey(customChalk));
    }
    else if (customChalk) {
        msg = customChalk("[ task ] ".concat(task));
    }
    else {
        msg = currentChalk.rgb(183, 84, 117)("[ task ] ".concat(task));
    }
    console.log(msg);
};
exports.logInitTask = logInitTask;
var logExitTask = function (task, customChalk) {
    if (_jsonOnly) {
        return _printJson({ type: 'taskExit', task: stripAnsi(_getCurrentTask()), message: stripAnsi(_sanitizePaths(typeof customChalk === 'string' ? customChalk : task)) });
    }
    var msg = '';
    if (typeof customChalk === 'string') {
        msg = "".concat(currentChalk.rgb(183, 84, 117)("[ task ] ".concat(task)), " ").concat(currentChalk.grey(customChalk));
    }
    else if (customChalk) {
        msg = customChalk("[ task ] ".concat(task));
    }
    else {
        msg = currentChalk.rgb(183, 84, 117)("[ task ] ".concat(task));
    }
    console.log(msg);
};
exports.logExitTask = logExitTask;
var logHook = function (hook, msg) {
    if (hook === void 0) { hook = ''; }
    if (msg === void 0) { msg = ''; }
    if (_jsonOnly) {
        var payload = { type: 'hook', hook: hook, message: stripAnsi(_sanitizePaths(msg)) };
        if (_getCurrentTask())
            payload.task = stripAnsi(_getCurrentTask());
        return _printJson(payload);
    }
    console.log("".concat(currentChalk.rgb(127, 255, 212)("[ hook ]".concat(_getCurrentTask(), " ").concat(hook)), " ").concat(currentChalk.grey(_sanitizePaths(msg))));
};
exports.logHook = logHook;
var logWarning = function (msg) {
    if (_jsonOnly) {
        return _printJson({ type: 'log', level: 'warning', task: stripAnsi(_getCurrentTask()), message: stripAnsi(_sanitizePaths(msg)) });
    }
    (0, exports.logAndSave)(currentChalk.yellow("[ warn ]".concat(_getCurrentTask(), " ").concat(_sanitizePaths(msg))));
};
exports.logWarning = logWarning;
var logInfo = function (msg) {
    if (_jsonOnly) {
        return _printJson({ type: 'log', level: 'info', task: stripAnsi(_getCurrentTask()), message: stripAnsi(_sanitizePaths(msg)) });
    }
    console.log(currentChalk.cyan("[ info ]".concat(_getCurrentTask(), " ").concat(_sanitizePaths(msg))));
};
exports.logInfo = logInfo;
var logDebug = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    if (_isInfoEnabled) {
        if (_jsonOnly) {
            return _printJson({ type: 'log', level: 'debug', task: stripAnsi(_getCurrentTask()), message: stripAnsi(_sanitizePaths.apply(void 0, args)) });
        }
        if (_infoFilter) {
            var firstArg_1 = args[0];
            if (_infoFilter.filter(function (v) { var _a; return (_a = firstArg_1 === null || firstArg_1 === void 0 ? void 0 : firstArg_1.includes) === null || _a === void 0 ? void 0 : _a.call(firstArg_1, v); }).length) {
                console.log.apply(null, args);
            }
        }
        else {
            console.log.apply(null, args);
        }
    }
};
exports.logDebug = logDebug;
var isInfoEnabled = function () { return _isInfoEnabled; };
exports.isInfoEnabled = isInfoEnabled;
var logComplete = function (isEnd) {
    if (isEnd === void 0) { isEnd = false; }
    if (_jsonOnly)
        return;
    console.log(currentChalk.bold.white("\n ".concat(RNV, " - Done! ").concat(ICN_ROCKET)));
    if (isEnd)
        (0, exports.logEnd)(0);
};
exports.logComplete = logComplete;
var logSuccess = function (msg) {
    if (_jsonOnly) {
        return _printJson({ type: 'success', task: stripAnsi(_getCurrentTask()), message: stripAnsi(_sanitizePaths(msg)) });
    }
    (0, exports.logAndSave)(currentChalk.magenta("[ success ]".concat(_getCurrentTask(), " ").concat(_sanitizePaths(msg))));
};
exports.logSuccess = logSuccess;
var logError = function (e, isEnd, skipAnalytics) {
    var _a, _b, _d, _e, _f, _g, _h, _j;
    if (isEnd === void 0) { isEnd = false; }
    if (skipAnalytics === void 0) { skipAnalytics = false; }
    if (!skipAnalytics && !!_analytics) {
        var extra = {
            command: (0, exports.getCurrentCommand)(),
            version: cnf().rnvVersion,
            engine: (_d = (_b = (_a = cnf().runtime) === null || _a === void 0 ? void 0 : _a.engine) === null || _b === void 0 ? void 0 : _b.config) === null || _d === void 0 ? void 0 : _d.id,
            platform: cnf().platform,
            bundleAssets: !!((_e = cnf().runtime) === null || _e === void 0 ? void 0 : _e.bundleAssets),
            os: (_f = cnf().process) === null || _f === void 0 ? void 0 : _f.platform,
            arch: (_g = cnf().process) === null || _g === void 0 ? void 0 : _g.arch,
            node: (_j = (_h = cnf().process) === null || _h === void 0 ? void 0 : _h.versions) === null || _j === void 0 ? void 0 : _j.node,
        };
        _analytics.captureException(e, { extra: extra });
    }
    if (_jsonOnly) {
        _printJson({ type: 'log', level: 'error', task: stripAnsi(_getCurrentTask()), message: stripAnsi(_sanitizePaths((e === null || e === void 0 ? void 0 : e.message) || e)) });
    }
    else if (e && e.message) {
        (0, exports.logAndSave)(currentChalk.red("[ error ]".concat(_getCurrentTask(), " ").concat(e.message, "\n").concat(e.stack)), isEnd);
    }
    else {
        (0, exports.logAndSave)(currentChalk.red("[ error ]".concat(_getCurrentTask(), " ").concat(e)), isEnd);
    }
    cnf().runtime.keepSessionActive = false;
    if (isEnd)
        (0, exports.logEnd)(1);
};
exports.logError = logError;
var logEnd = function (code) {
    if (!_jsonOnly) {
        (0, exports.logSummary)();
    }
    if (_currentProcess && !!_analytics) {
        _analytics.teardown().then(function () {
            _currentProcess.exit(code);
        });
    }
};
exports.logEnd = logEnd;
var logInitialize = function () {
    cnf();
    if (!_jsonOnly)
        (0, exports.logWelcome)();
};
exports.logInitialize = logInitialize;
var logAppInfo = function (c) {
    if (!_jsonOnly) {
        (0, exports.logInfo)("Current App Config: ".concat(currentChalk.bold.white(c.runtime.appId)));
    }
};
exports.logAppInfo = logAppInfo;
var printIntoBox = function (str) {
    var output = _defaultColor('│  ');
    var strLenDiff = str.length - stripAnsi(str).length;
    output += _defaultColor(str);
    var maxLen = 76;
    var len = maxLen - (str.length - strLenDiff);
    if (len > 0) {
        for (var i = 0; i < len; i++) {
            output += ' ';
        }
        output += _defaultColor('│\n');
    }
    else {
        output += _defaultColor('\n');
    }
    return output;
};
exports.printIntoBox = printIntoBox;
var printArrIntoBox = function (arr, prefix) {
    if (prefix === void 0) { prefix = ''; }
    if (_jsonOnly)
        return arr;
    var output = '';
    var stringArr = '';
    var i = 0;
    arr.forEach(function (v) {
        var l = i === 0 ? 60 - _defaultColor(prefix).length : 60;
        if (stringArr.length > l) {
            if (i === 0 && prefix.length) {
                output += (0, exports.printIntoBox)("".concat(_defaultColor(prefix)).concat(_defaultColor(stringArr)), 2);
            }
            else {
                output += (0, exports.printIntoBox)(_defaultColor(stringArr), 1);
            }
            stringArr = '';
            i++;
        }
        stringArr += "".concat(v, ", ");
        // stringArr[i] += `${c.platformDefaults[v].icon} ${currentChalk.white(v)}, `;
    });
    if (i === 0 && prefix.length) {
        output += (0, exports.printIntoBox)("".concat(_defaultColor(prefix)).concat(_defaultColor(stringArr.slice(0, -2))), 2);
    }
    else {
        output += (0, exports.printIntoBox)(_defaultColor(stringArr.slice(0, -2)), 1);
    }
    return output;
};
exports.printArrIntoBox = printArrIntoBox;
var printBoxStart = function (str, str2) {
    var output = _defaultColor('┌──────────────────────────────────────────────────────────────────────────────┐\n');
    output += (0, exports.printIntoBox)(str);
    output += (0, exports.printIntoBox)(str2 || '');
    output += _defaultColor('├──────────────────────────────────────────────────────────────────────────────┤\n');
    return output;
};
exports.printBoxStart = printBoxStart;
var printBoxEnd = function () { return _defaultColor('└──────────────────────────────────────────────────────────────────────────────┘'); };
exports.printBoxEnd = printBoxEnd;
exports.default = {
    chalk: exports.chalk,
    logHook: exports.logHook,
    logEnd: exports.logEnd,
    logInfo: exports.logInfo,
    logTask: exports.logTask,
    logError: exports.logError,
    logDebug: exports.logDebug,
    logAppInfo: exports.logAppInfo,
    logWarning: exports.logWarning,
    logSuccess: exports.logSuccess,
    logWelcome: exports.logWelcome,
    logComplete: exports.logComplete,
    logInitialize: exports.logInitialize
};
//# sourceMappingURL=logger.js.map