"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getScopedVersion = exports.isUrlLocalhost = exports.getValidLocalhost = exports.replaceOverridesInString = exports.isSystemWin = exports.isSystemLinux = exports.isSystemMac = void 0;
exports.isSystemMac = process.platform === 'darwin';
exports.isSystemLinux = process.platform === 'linux';
exports.isSystemWin = process.platform === 'win32';
var replaceOverridesInString = function (string, overrides, mask) {
    var replacedString = string;
    if ((overrides === null || overrides === void 0 ? void 0 : overrides.length) && (replacedString === null || replacedString === void 0 ? void 0 : replacedString.replace)) {
        overrides.forEach(function (v) {
            var regEx = new RegExp(v, 'g');
            replacedString = replacedString.replace(regEx, mask);
        });
    }
    return replacedString;
};
exports.replaceOverridesInString = replaceOverridesInString;
var getValidLocalhost = function (value, localhost) {
    if (!value)
        return localhost;
    switch (value) {
        case 'localhost':
        case '0.0.0.0':
        case '127.0.0.1':
            return localhost;
        default:
            return value;
    }
};
exports.getValidLocalhost = getValidLocalhost;
var isUrlLocalhost = function (value) {
    if (value === null || value === void 0 ? void 0 : value.includes) {
        if (value.includes('localhost'))
            return true;
        if (value.includes('0.0.0.0'))
            return true;
        if (value.includes('127.0.0.1'))
            return true;
    }
    return false;
};
exports.isUrlLocalhost = isUrlLocalhost;
var getScopedVersion = function (c, key, val, sourceObjKey) {
    var _a, _b;
    if (typeof val === 'string') {
        if (val.startsWith('source:')) {
            var sourceObj = (_a = c.buildConfig) === null || _a === void 0 ? void 0 : _a[sourceObjKey];
            if (sourceObj) {
                return (_b = sourceObj[key]) === null || _b === void 0 ? void 0 : _b.version;
            }
        }
        else {
            return val;
        }
    }
    else {
        return val === null || val === void 0 ? void 0 : val.version;
    }
    return null;
};
exports.getScopedVersion = getScopedVersion;
//# sourceMappingURL=utils.js.map