"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var engineManager_1 = require("../core/engineManager");
var task_rnv_crypto_decrypt_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.crypto.decrypt"));
var task_rnv_crypto_encrypt_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.crypto.encrypt"));
var task_rnv_platform_eject_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.platform.eject"));
var task_rnv_platform_connect_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.platform.connect"));
var task_rnv_platform_list_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.platform.list"));
var task_rnv_platform_configure_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.platform.configure"));
var task_rnv_platform_setup_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.platform.setup"));
var task_rnv_template_add_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.template.add"));
var task_rnv_template_apply_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.template.apply"));
var task_rnv_template_list_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.template.list"));
var task_rnv_plugin_add_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.plugin.add"));
var task_rnv_plugin_list_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.plugin.list"));
var task_rnv_plugin_update_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.plugin.update"));
var task_rnv_workspace_list_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.workspace.list"));
var task_rnv_workspace_add_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.workspace.add"));
var task_rnv_workspace_connect_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.workspace.connect"));
var task_rnv_workspace_update_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.workspace.update"));
var task_rnv_hooks_list_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.hooks.list"));
var task_rnv_hooks_run_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.hooks.run"));
var task_rnv_hooks_pipes_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.hooks.pipes"));
var task_rnv_clean_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.clean"));
var task_rnv_fastlane_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.fastlane"));
var task_rnv_publish_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.publish"));
var task_rnv_pkg_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.pkg"));
var task_rnv_status_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.status"));
var task_rnv_config_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.config"));
var task_rnv_help_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.help"));
var task_rnv_new_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.new"));
var task_rnv_install_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.install"));
var task_rnv_project_configure_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.project.configure"));
var task_rnv_project_upgrade_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.project.upgrade"));
var task_rnv_app_configure_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.app.configure"));
var task_rnv_app_create_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.app.create"));
var task_rnv_workspace_configure_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.workspace.configure"));
var task_rnv_configureSoft_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.configureSoft"));
var task_rnv_kill_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.kill"));
var task_rnv_doctor_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.doctor"));
var task_rnv_target_list_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.target.list"));
var task_rnv_target_launch_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.target.launch"));
var task_rnv_link_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.link"));
var task_rnv_unlink_1 = (0, tslib_1.__importDefault)(require("./tasks/task.rnv.unlink"));
exports.default = {
    initializeRuntimeConfig: function () { },
    tasks: (0, engineManager_1.generateEngineTasks)([
        task_rnv_crypto_decrypt_1.default,
        task_rnv_crypto_encrypt_1.default,
        task_rnv_platform_eject_1.default,
        task_rnv_platform_connect_1.default,
        task_rnv_platform_list_1.default,
        task_rnv_platform_configure_1.default,
        task_rnv_platform_setup_1.default,
        task_rnv_template_add_1.default,
        task_rnv_template_apply_1.default,
        task_rnv_template_list_1.default,
        task_rnv_plugin_add_1.default,
        task_rnv_plugin_list_1.default,
        task_rnv_plugin_update_1.default,
        task_rnv_workspace_list_1.default,
        task_rnv_workspace_add_1.default,
        task_rnv_workspace_connect_1.default,
        task_rnv_workspace_update_1.default,
        task_rnv_hooks_list_1.default,
        task_rnv_hooks_run_1.default,
        task_rnv_hooks_pipes_1.default,
        task_rnv_clean_1.default,
        task_rnv_fastlane_1.default,
        task_rnv_publish_1.default,
        task_rnv_pkg_1.default,
        task_rnv_status_1.default,
        task_rnv_config_1.default,
        task_rnv_help_1.default,
        task_rnv_new_1.default,
        task_rnv_install_1.default,
        task_rnv_project_configure_1.default,
        task_rnv_project_upgrade_1.default,
        task_rnv_app_configure_1.default,
        task_rnv_app_create_1.default,
        task_rnv_workspace_configure_1.default,
        task_rnv_configureSoft_1.default,
        task_rnv_kill_1.default,
        task_rnv_doctor_1.default,
        task_rnv_target_list_1.default,
        task_rnv_target_launch_1.default,
        task_rnv_link_1.default,
        task_rnv_unlink_1.default
    ]),
    config: {
        title: 'Engine Core',
        id: 'engine-core',
        platforms: {},
        npm: {}
    },
    package: {},
    projectDirName: '',
    ejectPlatform: null,
    platforms: null
};
//# sourceMappingURL=index.js.map