"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvConfig = void 0;
var tslib_1 = require("tslib");
var console_table_printer_1 = require("console-table-printer");
var logger_1 = require("../../core/systemManager/logger");
var constants_1 = require("../../core/constants");
var config_1 = (0, tslib_1.__importDefault)(require("../../core/configManager/config"));
var common_1 = require("../../core/common");
var taskRnvConfig = function (c) {
    (0, logger_1.logTask)('taskRnvConfig');
    var _a = (0, common_1.getCliArguments)(c), key = _a[1], value = _a[2]; // first arg is config so it's useless
    if (key === 'list') {
        var rows_1 = [];
        Object.keys(constants_1.configSchema).forEach(function (k) { return rows_1.push(config_1.default.listConfigValue(k)); });
        (0, console_table_printer_1.printTable)([].concat.apply([], rows_1));
        return true;
    }
    // validate args
    if (!key) {
        // @todo add inquirer with list of options
        (0, logger_1.logWarning)('Please specify a config');
        return true;
    }
    if (!constants_1.configSchema[key]) {
        (0, logger_1.logWarning)("Unknown config ".concat(key));
        return true;
    }
    if (!value) {
        // list the value
        (0, console_table_printer_1.printTable)(config_1.default.listConfigValue(key));
    }
    else if (config_1.default.setConfigValue(key, value)) {
        (0, console_table_printer_1.printTable)(config_1.default.listConfigValue(key));
    }
    return true;
};
exports.taskRnvConfig = taskRnvConfig;
exports.default = {
    description: 'Edit or display RNV configs',
    fn: exports.taskRnvConfig,
    task: 'config',
    params: constants_1.PARAMS.withBase(),
    platforms: [],
};
//# sourceMappingURL=task.rnv.config.js.map