"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvConfigureSoft = void 0;
var tslib_1 = require("tslib");
var logger_1 = require("../../core/systemManager/logger");
var schemeParser_1 = require("../../core/configManager/schemeParser");
var platformManager_1 = require("../../core/platformManager");
var runtimeManager_1 = require("../../core/runtimeManager");
var taskManager_1 = require("../../core/taskManager");
var constants_1 = require("../../core/constants");
var installer_1 = require("../../core/sdkManager/installer");
var taskRnvConfigureSoft = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvConfigureSoft');
                return [4 /*yield*/, (0, runtimeManager_1.configureRuntimeDefaults)(c)];
            case 1:
                _a.sent();
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_APP_CONFIGURE, parentTask, originTask)];
            case 2:
                _a.sent();
                return [4 /*yield*/, (0, platformManager_1.isPlatformSupported)(c)];
            case 3:
                _a.sent();
                return [4 /*yield*/, (0, schemeParser_1.isBuildSchemeSupported)(c)];
            case 4:
                _a.sent();
                return [4 /*yield*/, (0, installer_1.checkSdk)(c)];
            case 5:
                _a.sent();
                return [4 /*yield*/, (0, runtimeManager_1.configureRuntimeDefaults)(c)];
            case 6:
                _a.sent();
                return [2 /*return*/, true];
        }
    });
}); };
exports.taskRnvConfigureSoft = taskRnvConfigureSoft;
exports.default = {
    description: 'Configure system and project wothout recreating files (used for --only)',
    fn: exports.taskRnvConfigureSoft,
    task: constants_1.TASK_CONFIGURE_SOFT,
    params: constants_1.PARAMS.withBase(),
    platforms: [],
};
//# sourceMappingURL=task.rnv.configureSoft.js.map