"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvFastlane = void 0;
var tslib_1 = require("tslib");
var exec_1 = require("../../core/systemManager/exec");
var common_1 = require("../../core/common");
var constants_1 = require("../../core/constants");
var setupManager_1 = (0, tslib_1.__importDefault)(require("../../core/setupManager"));
var taskRnvFastlane = function (c) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var args, setupInstance, appFolder, fastlaneArgs;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                args = (0, common_1.getCliArguments)(c);
                args.shift(); // we know the first one is fastlane, trash it
                if (!!(0, exec_1.commandExistsSync)('fastlane')) return [3 /*break*/, 2];
                setupInstance = (0, setupManager_1.default)();
                return [4 /*yield*/, setupInstance.askToInstallSDK('fastlane')];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2:
                appFolder = (0, common_1.getAppFolder)(c, c.platform);
                fastlaneArgs = (0, tslib_1.__spreadArray)([], c.program.rawArgs, true);
                fastlaneArgs = fastlaneArgs.slice(3);
                return [2 /*return*/, (0, exec_1.executeAsync)(c, "fastlane ".concat(fastlaneArgs.join(' ')), {
                        interactive: true,
                        env: process.env,
                        cwd: appFolder
                    })];
        }
    });
}); };
exports.taskRnvFastlane = taskRnvFastlane;
exports.default = {
    description: 'Run fstalane commands directly',
    fn: exports.taskRnvFastlane,
    task: 'fastlane',
    params: constants_1.PARAMS.withBase(),
    platforms: [
        constants_1.IOS,
        constants_1.TVOS,
        constants_1.ANDROID,
        constants_1.ANDROID_TV,
        constants_1.FIRE_TV,
        constants_1.ANDROID_WEAR,
    ],
};
//# sourceMappingURL=task.rnv.fastlane.js.map