"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvHelp = void 0;
var logger_1 = require("../../core/systemManager/logger");
var constants_1 = require("../../core/constants");
var engineManager_1 = require("../../core/engineManager");
var taskRnvHelp = function (c) {
    (0, logger_1.logTask)('taskRnvHelp');
    // PARAMS
    var optsString = '';
    constants_1.PARAMS.withAll().forEach(function (param) {
        var cmd = '';
        if (param.shortcut) {
            cmd += "-".concat(param.shortcut, ", ");
        }
        cmd += "--".concat(param.key);
        if (param.value) {
            if (param.isRequired) {
                cmd += " <".concat(param.value, ">");
            }
            else {
                cmd += " [".concat(param.value, "]");
            }
        }
        optsString += (0, logger_1.chalk)().grey("".concat(cmd, ", ").concat(param.description, "\n"));
    });
    // TASKS
    var commands = [];
    var engines = (0, engineManager_1.getRegisteredEngines)(c);
    engines.forEach(function (engine) {
        Object.values(engine.tasks).forEach(function (_a) {
            var task = _a.task;
            commands.push(task);
        });
    });
    var cmdsString = commands.join(', ');
    (0, logger_1.logToSummary)("\n".concat((0, logger_1.chalk)().bold.white('COMMANDS:'), "\n\n").concat(cmdsString, "\n\n").concat((0, logger_1.chalk)().bold.white('OPTIONS:'), "\n\n").concat(optsString, "\n"));
};
exports.taskRnvHelp = taskRnvHelp;
exports.default = {
    description: 'Display generic help',
    fn: exports.taskRnvHelp,
    task: 'help',
    params: constants_1.PARAMS.withBase(),
    platforms: [],
    isGlobalScope: true
};
//# sourceMappingURL=task.rnv.help.js.map