"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvHooksList = void 0;
var tslib_1 = require("tslib");
var logger_1 = require("../../core/systemManager/logger");
var prompt_1 = require("../../cli/prompt");
var buildHooks_1 = require("../../core/projectManager/buildHooks");
var taskManager_1 = require("../../core/taskManager");
var constants_1 = require("../../core/constants");
var taskRnvHooksList = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var hookOpts, hooksAsString, pipeOpts;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvHooksList');
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_HOOKS_LIST, originTask)];
            case 1:
                _a.sent();
                return [4 /*yield*/, (0, buildHooks_1.buildHooks)(c)];
            case 2:
                _a.sent();
                if (c.buildHooks) {
                    hookOpts = (0, prompt_1.generateOptions)(c.buildHooks);
                    hooksAsString = "\n".concat('Hooks:', "\n").concat(hookOpts.asString);
                    if (c.buildPipes) {
                        pipeOpts = (0, prompt_1.generateOptions)(c.buildPipes);
                        hooksAsString += "\n".concat('Pipes:', "\n").concat(pipeOpts.asString);
                    }
                    (0, logger_1.logToSummary)(hooksAsString);
                    return [2 /*return*/, true];
                }
                return [2 /*return*/, Promise.reject('Your buildHooks object is empty!')];
        }
    });
}); };
exports.taskRnvHooksList = taskRnvHooksList;
exports.default = {
    description: 'Get list of all available hooks',
    fn: exports.taskRnvHooksList,
    task: constants_1.TASK_HOOKS_LIST,
    params: constants_1.PARAMS.withBase(),
    platforms: [],
    skipAppConfig: true,
    skipPlatforms: true,
    forceBuildHookRebuild: true
};
//# sourceMappingURL=task.rnv.hooks.list.js.map