"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvHooksPipes = void 0;
var tslib_1 = require("tslib");
var logger_1 = require("../../core/systemManager/logger");
var prompt_1 = require("../../cli/prompt");
var buildHooks_1 = require("../../core/projectManager/buildHooks");
var taskManager_1 = require("../../core/taskManager");
var constants_1 = require("../../core/constants");
var taskRnvHooksPipes = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var pipeOpts;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvHooksPipes');
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_HOOKS_PIPES, originTask)];
            case 1:
                _a.sent();
                return [4 /*yield*/, (0, buildHooks_1.buildHooks)(c)];
            case 2:
                _a.sent();
                pipeOpts = (0, prompt_1.generateOptions)(c.buildPipes);
                (0, logger_1.logRaw)("Pipes:\n".concat(pipeOpts.asString));
                return [2 /*return*/];
        }
    });
}); };
exports.taskRnvHooksPipes = taskRnvHooksPipes;
exports.default = {
    description: 'Get the list of all available pipes',
    fn: exports.taskRnvHooksPipes,
    task: constants_1.TASK_HOOKS_PIPES,
    params: constants_1.PARAMS.withBase(),
    platforms: [],
    skipAppConfig: true,
    skipPlatforms: true,
};
//# sourceMappingURL=task.rnv.hooks.pipes.js.map