"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvHooksRun = void 0;
var tslib_1 = require("tslib");
var inquirer_1 = (0, tslib_1.__importDefault)(require("inquirer"));
var logger_1 = require("../../core/systemManager/logger");
var buildHooks_1 = require("../../core/projectManager/buildHooks");
var taskManager_1 = require("../../core/taskManager");
var fileutils_1 = require("../../core/systemManager/fileutils");
var constants_1 = require("../../core/constants");
var taskRnvHooksRun = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var hookName, showHookList, hooksList, selectedHook;
    var _a;
    return (0, tslib_1.__generator)(this, function (_b) {
        switch (_b.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvHooksRun');
                if (!(0, fileutils_1.fsExistsSync)(c.paths.project.config)) return [3 /*break*/, 2];
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_HOOKS_RUN, originTask)];
            case 1:
                _b.sent();
                return [3 /*break*/, 3];
            case 2:
                (0, logger_1.logInfo)('Your are running your buildHook outside of renative project');
                _b.label = 3;
            case 3: return [4 /*yield*/, (0, buildHooks_1.buildHooks)(c)];
            case 4:
                _b.sent();
                if (!c.buildHooks) {
                    return [2 /*return*/, Promise.reject('Build hooks have not been compiled properly!')];
                }
                hookName = (_a = c.program) === null || _a === void 0 ? void 0 : _a.exeMethod;
                showHookList = false;
                if (!hookName || hookName === true) {
                    showHookList = true;
                }
                else if (!c.buildHooks[hookName]) {
                    showHookList = true;
                }
                if (!showHookList) return [3 /*break*/, 6];
                hooksList = Object.keys(c.buildHooks);
                return [4 /*yield*/, inquirer_1.default.prompt({
                        name: 'selectedHook',
                        type: 'list',
                        message: 'Pick an available hook:',
                        choices: hooksList
                    })];
            case 5:
                selectedHook = (_b.sent()).selectedHook;
                hookName = selectedHook;
                _b.label = 6;
            case 6: return [4 /*yield*/, c.buildHooks[hookName](c)];
            case 7:
                _b.sent();
                return [2 /*return*/, true];
        }
    });
}); };
exports.taskRnvHooksRun = taskRnvHooksRun;
exports.default = {
    description: 'Run specific build hook',
    fn: exports.taskRnvHooksRun,
    task: constants_1.TASK_HOOKS_RUN,
    params: constants_1.PARAMS.withBase([constants_1.PARAM_KEYS.exeMethod]),
    platforms: [],
    skipAppConfig: true,
    skipPlatforms: true,
    forceBuildHookRebuild: true,
    isGlobalScope: true
};
//# sourceMappingURL=task.rnv.hooks.run.js.map