"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvInstall = void 0;
var tslib_1 = require("tslib");
var npmUtils_1 = require("../../core/systemManager/npmUtils");
var constants_1 = require("../../core/constants");
var pluginManager_1 = require("../../core/pluginManager");
var logger_1 = require("../../core/systemManager/logger");
var taskRnvInstall = function (c, parentTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvInstall', "requiresInstall:".concat(!!c._requiresNpmInstall, ":").concat(!c.runtime.skipPackageUpdate));
                if (c.program.only && !!parentTask)
                    return [2 /*return*/, true];
                if (c.program.skipDependencyCheck)
                    return [2 /*return*/, true];
                if (!(!(0, npmUtils_1.areNodeModulesInstalled)() || c._requiresNpmInstall) /* && !c.runtime.skipPackageUpdate */) return [3 /*break*/, 2]; /* && !c.runtime.skipPackageUpdate */
                if (!(0, npmUtils_1.areNodeModulesInstalled)()) {
                    (0, logger_1.logInfo)('node_modules folder is missing. INSTALLING...');
                }
                else {
                    (0, logger_1.logInfo)('node_modules folder is out of date. INSTALLING...');
                }
                c._requiresNpmInstall = false;
                return [4 /*yield*/, (0, pluginManager_1.installPackageDependenciesAndPlugins)(c)];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2: return [2 /*return*/, true];
        }
    });
}); };
exports.taskRnvInstall = taskRnvInstall;
exports.default = {
    description: 'Install package node_modules via yarn or npm',
    fn: exports.taskRnvInstall,
    task: 'install',
    params: constants_1.PARAMS.withBase(),
    platforms: [],
    skipPlatforms: true,
};
//# sourceMappingURL=task.rnv.install.js.map