"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvKill = void 0;
var tslib_1 = require("tslib");
var kill_port_1 = (0, tslib_1.__importDefault)(require("kill-port"));
var prompt_1 = require("../../cli/prompt");
var common_1 = require("../../core/common");
var taskManager_1 = require("../../core/taskManager");
var logger_1 = require("../../core/systemManager/logger");
var runtimeManager_1 = require("../../core/runtimeManager");
var constants_1 = require("../../core/constants");
var taskRnvKill = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var usedPorts, platArray, results, ports, i, plat, port, usedPortsArr, confirm_1, killPromise_1;
    var _a, _b;
    return (0, tslib_1.__generator)(this, function (_c) {
        switch (_c.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvKill');
                usedPorts = [];
                platArray = [];
                results = [];
                return [4 /*yield*/, (0, runtimeManager_1.configureRuntimeDefaults)(c)];
            case 1:
                _c.sent();
                if (!c.paths.project.configExists) return [3 /*break*/, 4];
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_APP_CONFIGURE, constants_1.TASK_KILL, originTask)];
            case 2:
                _c.sent();
                return [4 /*yield*/, (0, runtimeManager_1.configureRuntimeDefaults)(c)];
            case 3:
                _c.sent();
                platArray = Object.values(c.runtime.supportedPlatforms);
                ports = ((_b = (_a = c.buildConfig) === null || _a === void 0 ? void 0 : _a.defaults) === null || _b === void 0 ? void 0 : _b.ports) || {};
                _c.label = 4;
            case 4:
                for (i = 0; i < platArray.length; i++) {
                    plat = platArray[i];
                    port = ports === null || ports === void 0 ? void 0 : ports[plat.platform];
                    plat.port = port;
                    results.push((0, common_1.checkPortInUse)(c, plat.platform, port));
                }
                return [4 /*yield*/, Promise.all(results)];
            case 5:
                usedPortsArr = _c.sent();
                usedPortsArr.forEach(function (isInUse, i) {
                    if (isInUse) {
                        usedPorts.push(platArray[i]);
                    }
                });
                if (!usedPorts.length) return [3 /*break*/, 8];
                return [4 /*yield*/, (0, prompt_1.inquirerPrompt)({
                        type: 'confirm',
                        message: 'Processes attached to the ports will be killed. Continue?',
                        warningMessage: "Found active ports:\n".concat(usedPorts.map(function (v) { return (0, logger_1.chalk)().white("> ".concat(v.port, " (").concat(v.platform, ")")); }).join('\n'))
                    })];
            case 6:
                confirm_1 = (_c.sent()).confirm;
                if (!confirm_1) return [3 /*break*/, 8];
                killPromise_1 = [];
                usedPorts.forEach(function (v) {
                    killPromise_1.push((0, kill_port_1.default)(v.port));
                });
                return [4 /*yield*/, Promise.all(usedPorts)];
            case 7:
                _c.sent();
                (0, logger_1.logSuccess)('Processes KILLED');
                _c.label = 8;
            case 8: return [2 /*return*/, true];
        }
    });
}); };
exports.taskRnvKill = taskRnvKill;
exports.default = {
    description: 'Kills all the processes related to this project',
    fn: exports.taskRnvKill,
    task: constants_1.TASK_KILL,
    params: constants_1.PARAMS.withBase(),
    platforms: [],
    isGlobalScope: true
};
//# sourceMappingURL=task.rnv.kill.js.map