"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvLink = void 0;
var tslib_1 = require("tslib");
var path_1 = (0, tslib_1.__importDefault)(require("path"));
var logger_1 = require("../../core/systemManager/logger");
var constants_1 = require("../../core/constants");
var fileutils_1 = require("../../core/systemManager/fileutils");
var _linkPackage = function (c, key, folder) {
    var rnvPath = path_1.default.join(c.paths.project.nodeModulesDir, key);
    var rnvPathUnlinked = path_1.default.join(c.paths.project.nodeModulesDir, "".concat(key, "_unlinked"));
    var pkgDir = path_1.default.join(c.paths.rnv.dir, '../', folder);
    if ((0, fileutils_1.fsExistsSync)(rnvPathUnlinked)) {
        (0, logger_1.logInfo)("".concat(key, " is already linked. SKIPPING"));
    }
    else if ((0, fileutils_1.fsExistsSync)(rnvPath)) {
        (0, fileutils_1.fsRenameSync)(rnvPath, rnvPathUnlinked);
        (0, fileutils_1.fsSymlinkSync)(pkgDir, rnvPath);
        (0, logger_1.logSuccess)("".concat(key, " => link => SUCCESS"));
    }
};
var taskRnvLink = function (c) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    return (0, tslib_1.__generator)(this, function (_a) {
        (0, logger_1.logTask)('taskRnvLink');
        constants_1.RNV_PACKAGES.forEach(function (pkg) {
            if (!pkg.skipLinking) {
                _linkPackage(c, pkg.packageName, pkg.folderName);
            }
        });
        return [2 /*return*/, true];
    });
}); };
exports.taskRnvLink = taskRnvLink;
exports.default = {
    description: '',
    fn: exports.taskRnvLink,
    task: 'link',
    params: constants_1.PARAMS.withBase(),
    platforms: [],
    skipPlatforms: true,
    isGlobalScope: true
};
//# sourceMappingURL=task.rnv.link.js.map