"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvPlatformConfigure = void 0;
var tslib_1 = require("tslib");
var logger_1 = require("../../core/systemManager/logger");
var fileutils_1 = require("../../core/systemManager/fileutils");
var common_1 = require("../../core/common");
var schemeParser_1 = require("../../core/configManager/schemeParser");
var platformManager_1 = require("../../core/platformManager");
var packageParser_1 = require("../../core/configManager/packageParser");
var runtimeManager_1 = require("../../core/runtimeManager");
var taskManager_1 = require("../../core/taskManager");
var constants_1 = require("../../core/constants");
var installer_1 = require("../../core/sdkManager/installer");
var taskRnvPlatformConfigure = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var hasBuild;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvPlatformConfigure', '');
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_PLATFORM_CONFIGURE, originTask)];
            case 1:
                _a.sent();
                if ((0, taskManager_1.shouldSkipTask)(c, constants_1.TASK_PLATFORM_CONFIGURE, originTask))
                    return [2 /*return*/, true];
                return [4 /*yield*/, (0, platformManager_1.isPlatformSupported)(c)];
            case 2:
                _a.sent();
                return [4 /*yield*/, (0, schemeParser_1.isBuildSchemeSupported)(c)];
            case 3:
                _a.sent();
                return [4 /*yield*/, (0, installer_1.checkSdk)(c)];
            case 4:
                _a.sent();
                return [4 /*yield*/, (0, runtimeManager_1.configureRuntimeDefaults)(c)];
            case 5:
                _a.sent();
                if (c.program.only && !!parentTask)
                    return [2 /*return*/, true];
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_INSTALL, constants_1.TASK_PLATFORM_CONFIGURE, originTask)];
            case 6:
                _a.sent();
                hasBuild = (0, fileutils_1.fsExistsSync)(c.paths.project.builds.dir);
                (0, logger_1.logTask)('', "taskRnvPlatformConfigure hasBuildFolderPresent:".concat(hasBuild));
                if (!((c.program.reset || c.program.resetHard) && !c.runtime.disableReset)) return [3 /*break*/, 8];
                (0, logger_1.logInfo)("You passed ".concat((0, logger_1.chalk)().white(c.program.reset ? '-r' : '-R'), " argument. \"").concat((0, logger_1.chalk)().white((0, common_1.getAppFolder)(c, c.platform)), "\" CLEANING...DONE"));
                return [4 /*yield*/, (0, platformManager_1.cleanPlatformBuild)(c, c.platform)];
            case 7:
                _a.sent();
                _a.label = 8;
            case 8: return [4 /*yield*/, (0, platformManager_1.createPlatformBuild)(c, c.platform)];
            case 9:
                _a.sent();
                return [4 /*yield*/, (0, packageParser_1.injectPlatformDependencies)(c)];
            case 10:
                _a.sent();
                // await _runCopyPlatforms(c);
                return [2 /*return*/, true];
        }
    });
}); };
exports.taskRnvPlatformConfigure = taskRnvPlatformConfigure;
exports.default = {
    description: '',
    fn: exports.taskRnvPlatformConfigure,
    task: constants_1.TASK_PLATFORM_CONFIGURE,
    params: constants_1.PARAMS.withBase(),
    platforms: [],
};
//# sourceMappingURL=task.rnv.platform.configure.js.map