"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvPlatformEject = void 0;
var tslib_1 = require("tslib");
var inquirer_1 = (0, tslib_1.__importDefault)(require("inquirer"));
var logger_1 = require("../../core/systemManager/logger");
var fileutils_1 = require("../../core/systemManager/fileutils");
var constants_1 = require("../../core/constants");
var platformManager_1 = require("../../core/platformManager");
var taskManager_1 = require("../../core/taskManager");
var taskRnvPlatformEject = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var selectedPlatforms, ejectedPlatforms;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvPlatformEject');
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_PLATFORM_EJECT, originTask)];
            case 1:
                _a.sent();
                if (!c.platform) return [3 /*break*/, 2];
                selectedPlatforms = [c.platform];
                return [3 /*break*/, 4];
            case 2:
                (0, logger_1.logInfo)("Preparing to eject engine platforms to local ".concat((0, logger_1.chalk)().white('./platformTemplates')));
                return [4 /*yield*/, inquirer_1.default.prompt({
                        name: 'ejectedPlatforms',
                        message: 'Select platforms you would like to eject (use SPACE key)',
                        type: 'checkbox',
                        choices: (0, platformManager_1.generatePlatformChoices)(c).map(function (choice) { return ((0, tslib_1.__assign)((0, tslib_1.__assign)({}, choice), { disabled: !choice.isConnected })); })
                    })];
            case 3:
                ejectedPlatforms = (_a.sent()).ejectedPlatforms;
                selectedPlatforms = ejectedPlatforms;
                _a.label = 4;
            case 4:
                if (selectedPlatforms.length) {
                    selectedPlatforms.forEach(function (platform) {
                        // const engine = getEngineRunnerByPlatform(c, platform);
                        // const destDir = path.join(c.paths.project.dir, 'platformTemplates', platform);
                        // engine.ejectPlatform(c, platform, destDir);
                        (0, platformManager_1.ejectPlatform)(c, platform);
                        c.files.project.config_original.paths = c.files.project.config_original.paths || {};
                        c.files.project.config_original.paths
                            .platformTemplatesDirs = c.files.project.config_original.paths.platformTemplatesDirs || {};
                        c.files.project.config_original.paths.platformTemplatesDirs[platform] = "./".concat('platformTemplates');
                        (0, fileutils_1.writeFileSync)(c.paths.project.config, c.files.project.config_original);
                    });
                    (0, logger_1.logSuccess)("".concat((0, logger_1.chalk)().white(selectedPlatforms.join(',')), " platform templates are located in ").concat((0, logger_1.chalk)().white(c.files.project.config.paths.platformTemplatesDirs[selectedPlatforms[0]]), " now. You can edit them directly!"));
                }
                else {
                    (0, logger_1.logError)("You haven't selected any platform to eject.\nTIP: You can select options with ".concat((0, logger_1.chalk)().white('SPACE'), " key before pressing ENTER!"));
                }
                return [2 /*return*/];
        }
    });
}); };
exports.taskRnvPlatformEject = taskRnvPlatformEject;
exports.default = {
    description: 'Copy all platform files directly to project',
    fn: exports.taskRnvPlatformEject,
    task: 'platform eject',
    params: constants_1.PARAMS.withBase(),
    platforms: [],
};
//# sourceMappingURL=task.rnv.platform.eject.js.map