"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvPlatformList = void 0;
var tslib_1 = require("tslib");
var logger_1 = require("../../core/systemManager/logger");
// import { generateOptions } from '../../cli/prompt';
var platformManager_1 = require("../../core/platformManager");
var taskManager_1 = require("../../core/taskManager");
var constants_1 = require("../../core/constants");
var taskRnvPlatformList = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var opts;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvPlatformList');
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_PLATFORM_LIST, originTask)];
            case 1:
                _a.sent();
                opts = (0, platformManager_1.generatePlatformChoices)(c).map(function (v, i) { return " [".concat((0, logger_1.chalk)().white(i + 1), "]> ").concat(v.name); });
                (0, logger_1.logToSummary)("Platforms:\n\n".concat(opts.join('\n')));
                return [2 /*return*/, true];
        }
    });
}); };
exports.taskRnvPlatformList = taskRnvPlatformList;
exports.default = {
    description: 'List all available platforms',
    fn: exports.taskRnvPlatformList,
    task: 'platform list',
    params: constants_1.PARAMS.withBase(),
    platforms: [],
    skipPlatforms: true,
};
//# sourceMappingURL=task.rnv.platform.list.js.map