"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvPlatformSetup = void 0;
var tslib_1 = require("tslib");
var inquirer_1 = (0, tslib_1.__importDefault)(require("inquirer"));
var constants_1 = require("../../core/constants");
var platformManager_1 = require("../../core/platformManager");
var logger_1 = require("../../core/systemManager/logger");
var taskManager_1 = require("../../core/taskManager");
var taskRnvPlatformSetup = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var currentPlatforms, inputSupportedPlatforms;
    var _a;
    return (0, tslib_1.__generator)(this, function (_b) {
        switch (_b.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvPlatformSetup');
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_PLATFORM_SETUP, originTask)];
            case 1:
                _b.sent();
                currentPlatforms = ((_a = c.files.project.config.defaults) === null || _a === void 0 ? void 0 : _a.supportedPlatforms) || [];
                return [4 /*yield*/, inquirer_1.default.prompt({
                        name: 'inputSupportedPlatforms',
                        type: 'checkbox',
                        pageSize: 20,
                        message: 'What platforms would you like to use?',
                        validate: function (val) { return !!val.length || 'Please select at least a platform'; },
                        default: currentPlatforms,
                        choices: c.runtime.availablePlatforms
                    })];
            case 2:
                inputSupportedPlatforms = (_b.sent()).inputSupportedPlatforms;
                (0, platformManager_1.updateProjectPlatforms)(c, inputSupportedPlatforms);
                return [2 /*return*/];
        }
    });
}); };
exports.taskRnvPlatformSetup = taskRnvPlatformSetup;
exports.default = {
    description: '',
    fn: exports.taskRnvPlatformSetup,
    task: constants_1.TASK_PLATFORM_SETUP,
    params: constants_1.PARAMS.withBase(),
    platforms: [],
    skipPlatforms: true,
};
//# sourceMappingURL=task.rnv.platform.setup.js.map