"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvPluginAdd = void 0;
var tslib_1 = require("tslib");
var inquirer_1 = (0, tslib_1.__importDefault)(require("inquirer"));
var ora_1 = (0, tslib_1.__importDefault)(require("../../cli/ora"));
var configManager_1 = require("../../core/configManager");
var constants_1 = require("../../core/constants");
var logger_1 = require("../../core/systemManager/logger");
var pluginManager_1 = require("../../core/pluginManager");
var taskManager_1 = require("../../core/taskManager");
/* eslint-disable no-await-in-loop */
var taskRnvPluginAdd = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var selPluginKey, o, selPlugin, selectedPlugins, installMessage, plugin, questionPlugins, pluginKeys, i, pluginKey, plugin, pluginProps, finalProps, i2, propValue, spinner;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvPluginAdd');
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_PLUGIN_ADD, originTask)];
            case 1:
                _a.sent();
                selPluginKey = c.program.rawArgs[4];
                o = (0, pluginManager_1.getPluginList)(c);
                selPlugin = selPluginKey && o.allPlugins[selPluginKey];
                selectedPlugins = {};
                installMessage = [];
                if (!!selPlugin) return [3 /*break*/, 3];
                return [4 /*yield*/, inquirer_1.default.prompt({
                        name: 'plugin',
                        type: 'rawlist',
                        message: 'Select the plugins you want to add',
                        choices: o.asArray,
                        pageSize: 50
                    })];
            case 2:
                plugin = (_a.sent()).plugin;
                selectedPlugins[plugin] = o.allPlugins[plugin];
                installMessage.push("".concat((0, logger_1.chalk)().white(plugin), " v(").concat((0, logger_1.chalk)().green(o.allPlugins[plugin].version), ")"));
                return [3 /*break*/, 4];
            case 3:
                selectedPlugins[selPluginKey] = selPlugin;
                installMessage.push("".concat((0, logger_1.chalk)().white(selPluginKey), " v(").concat((0, logger_1.chalk)().green(selPlugin.version), ")"));
                _a.label = 4;
            case 4:
                questionPlugins = {};
                Object.keys(selectedPlugins).forEach(function (key) {
                    // c.buildConfig.plugins[key] = 'source:rnv';
                    var plugin = selectedPlugins[key];
                    if (plugin.props)
                        questionPlugins[key] = plugin;
                    c.files.project.config_original.plugins[key] = 'source:rnv';
                    // c.buildConfig.plugins[key] = selectedPlugins[key];
                });
                pluginKeys = Object.keys(questionPlugins);
                i = 0;
                _a.label = 5;
            case 5:
                if (!(i < pluginKeys.length)) return [3 /*break*/, 11];
                pluginKey = pluginKeys[i];
                plugin = questionPlugins[pluginKey];
                pluginProps = Object.keys(plugin.props);
                finalProps = {};
                i2 = 0;
                _a.label = 6;
            case 6:
                if (!(i2 < pluginProps.length)) return [3 /*break*/, 9];
                return [4 /*yield*/, inquirer_1.default.prompt({
                        name: 'propValue',
                        type: 'input',
                        message: "".concat(pluginKey, ": Add value for ").concat(pluginProps[i2], " (You can do this later in ./renative.json file)")
                    })];
            case 7:
                propValue = (_a.sent()).propValue;
                finalProps[pluginProps[i2]] = propValue;
                _a.label = 8;
            case 8:
                i2++;
                return [3 /*break*/, 6];
            case 9:
                c.files.project.config_original.plugins[pluginKey] = {};
                c.files.project.config.config_original[pluginKey].props = finalProps;
                _a.label = 10;
            case 10:
                i++;
                return [3 /*break*/, 5];
            case 11:
                spinner = (0, ora_1.default)("Installing: ".concat(installMessage.join(', '))).start();
                (0, configManager_1.writeRenativeConfigFile)(c, c.paths.project.config, c.files.project.config_original);
                return [4 /*yield*/, (0, pluginManager_1.resolvePluginDependants)(c)];
            case 12:
                _a.sent();
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_INSTALL, constants_1.TASK_PLUGIN_ADD, originTask)];
            case 13:
                _a.sent();
                spinner.succeed('All plugins installed!');
                (0, logger_1.logSuccess)('Plugins installed successfully!');
                return [2 /*return*/, true];
        }
    });
}); };
exports.taskRnvPluginAdd = taskRnvPluginAdd;
exports.default = {
    description: 'Add selected plugin to the project',
    fn: exports.taskRnvPluginAdd,
    task: 'plugin add',
    params: constants_1.PARAMS.withBase(),
    platforms: [],
};
//# sourceMappingURL=task.rnv.plugin.add.js.map