"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvPluginUpdate = void 0;
var tslib_1 = require("tslib");
var inquirer_1 = (0, tslib_1.__importDefault)(require("inquirer"));
var fileutils_1 = require("../../core/systemManager/fileutils");
var logger_1 = require("../../core/systemManager/logger");
var pluginManager_1 = require("../../core/pluginManager");
var taskManager_1 = require("../../core/taskManager");
var constants_1 = require("../../core/constants");
var taskRnvPluginUpdate = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var o, confirm, plugins;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvPluginUpdate');
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_PLUGIN_UPDATE, originTask)];
            case 1:
                _a.sent();
                o = (0, pluginManager_1.getPluginList)(c, true);
                return [4 /*yield*/, inquirer_1.default.prompt({
                        name: 'confirm',
                        type: 'confirm',
                        message: 'Above installed plugins will be updated with RNV'
                    })];
            case 2:
                confirm = (_a.sent()).confirm;
                if (confirm) {
                    plugins = c.buildConfig.plugins;
                    Object.keys(plugins).forEach(function (key) {
                        // c.buildConfig.plugins[key] = o.json[key];
                        c.files.project.config_original.plugins[key] = o.json[key];
                    });
                    (0, fileutils_1.writeFileSync)(c.paths.project.config, c.files.project.config_original);
                    (0, logger_1.logSuccess)('Plugins updated successfully!');
                }
                return [2 /*return*/];
        }
    });
}); };
exports.taskRnvPluginUpdate = taskRnvPluginUpdate;
exports.default = {
    description: 'Update specific plugin to latest supported version (rnv)',
    fn: exports.taskRnvPluginUpdate,
    task: 'plugin update',
    params: constants_1.PARAMS.withBase(),
    platforms: [],
};
//# sourceMappingURL=task.rnv.plugin.update.js.map