"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvTargetList = void 0;
var tslib_1 = require("tslib");
var platformManager_1 = require("../../core/platformManager");
var logger_1 = require("../../core/systemManager/logger");
var installer_1 = require("../../core/sdkManager/installer");
var constants_1 = require("../../core/constants");
var tizen_1 = require("../../core/sdkManager/deviceUtils/tizen");
var webos_1 = require("../../core/sdkManager/deviceUtils/webos");
var android_1 = require("../../core/sdkManager/deviceUtils/android");
var apple_1 = require("../../core/sdkManager/deviceUtils/apple");
var taskManager_1 = require("../../core/taskManager");
var taskRnvTargetList = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var platform;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvTargetList');
                return [4 /*yield*/, (0, platformManager_1.isPlatformSupported)(c, true)];
            case 1:
                _a.sent();
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_WORKSPACE_CONFIGURE, constants_1.TASK_TARGET_LAUNCH, originTask)];
            case 2:
                _a.sent();
                platform = c.platform;
                return [4 /*yield*/, (0, installer_1.checkSdk)(c)];
            case 3:
                _a.sent();
                switch (platform) {
                    case constants_1.ANDROID:
                    case constants_1.ANDROID_TV:
                    case constants_1.FIRE_TV:
                    case constants_1.ANDROID_WEAR:
                        return [2 /*return*/, (0, android_1.listAndroidTargets)(c, platform)];
                    case constants_1.IOS:
                    case constants_1.TVOS:
                        return [2 /*return*/, (0, apple_1.listAppleDevices)(c)];
                    case constants_1.TIZEN:
                        return [2 /*return*/, (0, tizen_1.listTizenTargets)(c, platform)];
                    case constants_1.WEBOS:
                        return [2 /*return*/, (0, webos_1.listWebOSTargets)(c)];
                    default:
                        return [2 /*return*/, Promise.reject("\"target list\" command does not support ".concat((0, logger_1.chalk)().white.bold(platform), " platform yet. Working on it!"))];
                }
                return [2 /*return*/];
        }
    });
}); };
exports.taskRnvTargetList = taskRnvTargetList;
exports.default = {
    description: 'List all available devices / emulators for specific platform',
    fn: exports.taskRnvTargetList,
    task: 'target list',
    params: constants_1.PARAMS.withBase(),
    platforms: [],
    isGlobalScope: true
};
//# sourceMappingURL=task.rnv.target.list.js.map