"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvTemplateAdd = exports._addTemplate = void 0;
var tslib_1 = require("tslib");
var inquirer_1 = (0, tslib_1.__importDefault)(require("inquirer"));
var fileutils_1 = require("../../core/systemManager/fileutils");
var logger_1 = require("../../core/systemManager/logger");
var configManager_1 = require("../../core/configManager");
var taskManager_1 = require("../../core/taskManager");
var constants_1 = require("../../core/constants");
var templateManager_1 = require("../../core/templateManager");
var _writeObjectSync = function (c, p, s) {
    (0, fileutils_1.writeFileSync)(p, s);
    (0, configManager_1.generateBuildConfig)(c);
};
var _addTemplate = function (c, template) {
    (0, logger_1.logTask)('addTemplate');
    c.files.project.config.templates = c.files.project.config.templates || {};
    if (!c.files.project.config.templates[template]) {
        c.files.project.config.templates[template] = {
            version: 'latest'
        };
    }
    _writeObjectSync(c, c.paths.project.config, c.files.project.config);
};
exports._addTemplate = _addTemplate;
var taskRnvTemplateAdd = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var opts, template;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvTemplateAdd');
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_TEMPLATE_ADD, originTask)];
            case 1:
                _a.sent();
                opts = (0, templateManager_1.getTemplateOptions)(c);
                return [4 /*yield*/, inquirer_1.default.prompt({
                        type: 'list',
                        message: 'Pick which template to install',
                        name: 'template',
                        choices: opts.keysAsArray
                    })];
            case 2:
                template = (_a.sent()).template;
                (0, exports._addTemplate)(c, template);
                return [2 /*return*/];
        }
    });
}); };
exports.taskRnvTemplateAdd = taskRnvTemplateAdd;
exports.default = {
    description: 'Install additional template to the project',
    fn: exports.taskRnvTemplateAdd,
    task: 'template add',
    params: constants_1.PARAMS.withBase(),
    platforms: [],
};
//# sourceMappingURL=task.rnv.template.add.js.map