"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvTemplateApply = void 0;
var tslib_1 = require("tslib");
var inquirer_1 = (0, tslib_1.__importDefault)(require("inquirer"));
var logger_1 = require("../../core/systemManager/logger");
var templateManager_1 = require("../../core/templateManager");
var taskManager_1 = require("../../core/taskManager");
var constants_1 = require("../../core/constants");
var taskRnvTemplateApply = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var opts, template;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvTemplateApply', "template: ".concat(c.program.template));
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_TEMPLATE_APPLY, originTask)];
            case 1:
                _a.sent();
                if (c.files.project.config.isTemplate) {
                    return [2 /*return*/, Promise.reject('Template projects cannot use template apply command')];
                }
                if (!c.program.template) return [3 /*break*/, 5];
                return [4 /*yield*/, (0, templateManager_1.applyTemplate)(c, c.program.template)];
            case 2:
                _a.sent();
                if (!c.program.appConfigID) return [3 /*break*/, 4];
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_APP_CONFIGURE, constants_1.TASK_TEMPLATE_APPLY, originTask)];
            case 3:
                _a.sent();
                _a.label = 4;
            case 4: return [2 /*return*/, true];
            case 5:
                opts = (0, templateManager_1.getInstalledTemplateOptions)(c);
                return [4 /*yield*/, inquirer_1.default.prompt({
                        type: 'list',
                        message: 'Pick which template to install',
                        name: 'template',
                        choices: opts.keysAsArray
                    })];
            case 6:
                template = (_a.sent()).template;
                return [4 /*yield*/, (0, templateManager_1.applyTemplate)(c, template)];
            case 7:
                _a.sent();
                if (!c.program.appConfigID) return [3 /*break*/, 9];
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_APP_CONFIGURE, constants_1.TASK_TEMPLATE_APPLY, originTask)];
            case 8:
                _a.sent();
                _a.label = 9;
            case 9: return [2 /*return*/, true];
        }
    });
}); };
exports.taskRnvTemplateApply = taskRnvTemplateApply;
exports.default = {
    description: 'Reset project to specific template',
    fn: exports.taskRnvTemplateApply,
    task: 'template apply',
    params: constants_1.PARAMS.withBase(),
    platforms: [],
};
//# sourceMappingURL=task.rnv.template.apply.js.map