"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvTemplateList = void 0;
var tslib_1 = require("tslib");
var logger_1 = require("../../core/systemManager/logger");
var templateManager_1 = require("../../core/templateManager");
var taskManager_1 = require("../../core/taskManager");
var constants_1 = require("../../core/constants");
var taskRnvTemplateList = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var opts;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvTemplateList');
                if (!c.paths.project.configExists) return [3 /*break*/, 2];
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_TEMPLATE_LIST, originTask)];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2:
                opts = (0, templateManager_1.getTemplateOptions)(c, !c.paths.project.configExists);
                (0, logger_1.logToSummary)("Templates:\n\n".concat(opts.asString));
                return [2 /*return*/, true];
        }
    });
}); };
exports.taskRnvTemplateList = taskRnvTemplateList;
exports.default = {
    description: 'Show list of available templates',
    fn: exports.taskRnvTemplateList,
    task: 'template list',
    params: constants_1.PARAMS.withBase(),
    platforms: [],
    skipPlatforms: true,
    isGlobalScope: true
};
//# sourceMappingURL=task.rnv.template.list.js.map