"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvUnlink = void 0;
var tslib_1 = require("tslib");
var path_1 = (0, tslib_1.__importDefault)(require("path"));
var logger_1 = require("../../core/systemManager/logger");
var constants_1 = require("../../core/constants");
var fileutils_1 = require("../../core/systemManager/fileutils");
var _unlinkPackage = function (c, key) {
    var rnvPath = path_1.default.join(c.paths.project.nodeModulesDir, key);
    var rnvPathUnlinked = path_1.default.join(c.paths.project.nodeModulesDir, "".concat(key, "_unlinked"));
    if (!(0, fileutils_1.fsExistsSync)(rnvPathUnlinked)) {
        (0, logger_1.logInfo)("".concat(key, " is not linked. SKIPPING"));
    }
    else if ((0, fileutils_1.fsExistsSync)(rnvPath)) {
        if ((0, fileutils_1.fsLstatSync)(rnvPath).isSymbolicLink()) {
            (0, fileutils_1.fsUnlinkSync)(rnvPath);
            (0, fileutils_1.fsRenameSync)(rnvPathUnlinked, rnvPath);
            (0, logger_1.logSuccess)("".concat(key, " => unlink => SUCCESS"));
        }
        else {
            (0, logger_1.logInfo)("".concat(key, " is not a symlink anymore. SKIPPING"));
        }
    }
};
var taskRnvUnlink = function (c) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    return (0, tslib_1.__generator)(this, function (_a) {
        (0, logger_1.logTask)('taskRnvUnlink');
        constants_1.RNV_PACKAGES.forEach(function (pkg) {
            if (!pkg.skipLinking) {
                _unlinkPackage(c, pkg.packageName);
            }
        });
        return [2 /*return*/, true];
    });
}); };
exports.taskRnvUnlink = taskRnvUnlink;
exports.default = {
    description: '',
    fn: exports.taskRnvUnlink,
    task: 'unlink',
    params: constants_1.PARAMS.withBase(),
    platforms: [],
    skipPlatforms: true,
    isGlobalScope: true
};
//# sourceMappingURL=task.rnv.unlink.js.map