"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvWorkspaceAdd = void 0;
var tslib_1 = require("tslib");
var path_1 = (0, tslib_1.__importDefault)(require("path"));
var prompt_1 = require("../../cli/prompt");
var logger_1 = require("../../core/systemManager/logger");
var workspace_1 = require("../../core/projectManager/workspace");
var fileutils_1 = require("../../core/systemManager/fileutils");
var taskManager_1 = require("../../core/taskManager");
var constants_1 = require("../../core/constants");
var taskRnvWorkspaceAdd = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var workspace, workspacePath, confirm_1, workspaceID, workspaceIDInput;
    return (0, tslib_1.__generator)(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvWorkspaceAdd');
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_WORKSPACE_ADD, originTask)];
            case 1:
                _a.sent();
                return [4 /*yield*/, (0, prompt_1.inquirerPrompt)({
                        name: 'workspace',
                        type: 'input',
                        message: 'absolute path to new workspace',
                        validate: function (i) { return !!i || 'No path provided'; }
                    })];
            case 2:
                workspace = (_a.sent()).workspace;
                workspacePath = path_1.default.join(workspace);
                if (!(0, fileutils_1.fsExistsSync)(workspacePath)) return [3 /*break*/, 4];
                return [4 /*yield*/, (0, prompt_1.inquirerPrompt)({
                        name: 'confirm',
                        type: 'confirm',
                        message: "Folder ".concat(workspacePath, " already exists are you sure you want to override it?")
                    })];
            case 3:
                confirm_1 = (_a.sent()).confirm;
                if (!confirm_1)
                    return [2 /*return*/];
                _a.label = 4;
            case 4:
                workspaceID = workspacePath
                    .split('/')
                    .pop()
                    .replace(/@|\./g, '');
                return [4 /*yield*/, (0, prompt_1.inquirerPrompt)({
                        name: 'workspaceIDInput',
                        type: 'input',
                        message: "ID of the workspace (".concat(workspaceID, ")")
                    })];
            case 5:
                workspaceIDInput = (_a.sent()).workspaceIDInput;
                workspaceID = workspaceIDInput || workspaceID;
                (0, workspace_1.createWorkspace)(c, workspaceID, workspacePath);
                return [2 /*return*/];
        }
    });
}); };
exports.taskRnvWorkspaceAdd = taskRnvWorkspaceAdd;
exports.default = {
    description: 'Add new workspace',
    fn: exports.taskRnvWorkspaceAdd,
    task: constants_1.TASK_WORKSPACE_ADD,
    params: constants_1.PARAMS.withBase(),
    platforms: [],
    isGlobalScope: true
};
//# sourceMappingURL=task.rnv.workspace.add.js.map