"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvWorkspaceConnect = void 0;
var tslib_1 = require("tslib");
var prompt_1 = require("../../cli/prompt");
var logger_1 = require("../../core/systemManager/logger");
var workspace_1 = require("../../core/projectManager/workspace");
var taskManager_1 = require("../../core/taskManager");
var constants_1 = require("../../core/constants");
var taskRnvWorkspaceConnect = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var opts, selectedWS;
    var _a;
    return (0, tslib_1.__generator)(this, function (_b) {
        switch (_b.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvWorkspaceConnect');
                if (!c.paths.project.configExists) {
                    return [2 /*return*/, Promise.reject("".concat(constants_1.TASK_PROJECT_CONFIGURE, " not supported outside of renative project"))];
                }
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_WORKSPACE_CONNECT, originTask)];
            case 1:
                _b.sent();
                opts = Object.keys((_a = c.files.rnv.configWorkspaces) === null || _a === void 0 ? void 0 : _a.workspaces).map(function (v) {
                    var _a;
                    return "".concat(v, " ").concat((0, workspace_1.getWorkspaceConnectionString)((_a = c.files.rnv.configWorkspaces) === null || _a === void 0 ? void 0 : _a.workspaces[v]));
                });
                return [4 /*yield*/, (0, prompt_1.inquirerPrompt)({
                        type: 'list',
                        name: 'selectedWS',
                        message: 'Pick a workspace',
                        choices: opts
                    })];
            case 2:
                selectedWS = (_b.sent()).selectedWS;
                (0, logger_1.logRaw)(selectedWS);
                return [2 /*return*/];
        }
    });
}); };
exports.taskRnvWorkspaceConnect = taskRnvWorkspaceConnect;
exports.default = {
    description: 'Connect project with selected workspace',
    fn: exports.taskRnvWorkspaceConnect,
    task: constants_1.TASK_WORKSPACE_CONNECT,
    params: constants_1.PARAMS.withBase(),
    platforms: [],
    isGlobalScope: true
};
//# sourceMappingURL=task.rnv.workspace.connect.js.map