"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRnvWorkspaceList = void 0;
var tslib_1 = require("tslib");
var prompt_1 = require("../../cli/prompt");
var logger_1 = require("../../core/systemManager/logger");
var taskManager_1 = require("../../core/taskManager");
var constants_1 = require("../../core/constants");
var taskRnvWorkspaceList = function (c, parentTask, originTask) { return (0, tslib_1.__awaiter)(void 0, void 0, void 0, function () {
    var opts;
    var _a;
    return (0, tslib_1.__generator)(this, function (_b) {
        switch (_b.label) {
            case 0:
                (0, logger_1.logTask)('taskRnvWorkspaceList');
                if (!c.paths.project.configExists) return [3 /*break*/, 2];
                return [4 /*yield*/, (0, taskManager_1.executeTask)(c, constants_1.TASK_PROJECT_CONFIGURE, constants_1.TASK_WORKSPACE_LIST, originTask)];
            case 1:
                _b.sent();
                _b.label = 2;
            case 2:
                opts = (0, prompt_1.generateOptions)((_a = c.files.rnv.configWorkspaces) === null || _a === void 0 ? void 0 : _a.workspaces, true, null, function (i, obj, mapping, defaultVal) {
                    var isConnected = '';
                    return " [".concat((0, logger_1.chalk)().grey(i + 1), "]> ").concat((0, logger_1.chalk)().bold(defaultVal)).concat(isConnected, " \n");
                });
                (0, logger_1.logToSummary)("Workspaces:\n\n".concat(opts.asString));
                return [2 /*return*/];
        }
    });
}); };
exports.taskRnvWorkspaceList = taskRnvWorkspaceList;
exports.default = {
    description: 'Show list of all available workspaces',
    fn: exports.taskRnvWorkspaceList,
    task: constants_1.TASK_WORKSPACE_LIST,
    params: constants_1.PARAMS.withBase(),
    platforms: [],
    isGlobalScope: true
};
//# sourceMappingURL=task.rnv.workspace.list.js.map