/// <reference types="node" />
export function initializeBuilder(cmd: any, subCmd: any, process: any, program: any): Promise<{
    _renativePluginCache: {};
    cli: {};
    api: {
        fsExistsSync: (dest: any) => boolean;
        fsReadFileSync: (dest: any) => Buffer;
        fsReaddirSync: (dest: any) => string[];
        fsWriteFileSync: (dest: any, data: any, encoding: any) => void;
        path: import("path").PlatformPath;
    };
    configPropsInjects: {};
    runtime: {
        enginesByPlatform: {};
        enginesByIndex: never[];
        enginesById: {};
    };
    paths: {
        rnv: {
            pluginTemplates: {
                configs: {};
            };
            platformTemplates: {};
            projectTemplates: {};
            platformTemplate: {};
            plugins: {};
            engines: {};
            projectTemplate: {};
        };
        workspace: {
            project: {
                appConfigBase: {};
                builds: {};
                assets: {};
                platformTemplates: {};
                appConfigsDirs: never[];
                appConfigsDirNames: never[];
            };
            appConfig: {
                configs: never[];
                configsPrivate: never[];
                configsLocal: never[];
            };
        };
        defaultWorkspace: {
            project: {
                appConfigBase: {};
                builds: {};
                assets: {};
                platformTemplates: {};
                appConfigsDirs: never[];
                appConfigsDirNames: never[];
            };
            appConfig: {
                configs: never[];
                configsPrivate: never[];
                configsLocal: never[];
            };
        };
        project: {
            appConfigBase: {};
            builds: {};
            assets: {};
            platformTemplates: {};
            appConfigsDirs: never[];
            appConfigsDirNames: never[];
        };
        appConfig: {
            configs: never[];
            configsPrivate: never[];
            configsLocal: never[];
        };
        GLOBAL_RNV_DIR: string;
        buildHooks: {
            dist: {};
        };
        home: {};
        template: {
            appConfigBase: {};
            builds: {};
            assets: {};
            platformTemplates: {};
        };
    };
    files: {
        rnv: {
            pluginTemplates: {};
            platformTemplates: {};
            projectTemplates: {};
            platformTemplate: {};
            plugins: {};
            engines: {};
            projectTemplate: {};
        };
        workspace: {
            project: {
                appConfigBase: {};
                builds: {};
                assets: {};
                platformTemplates: {};
            };
            appConfig: {
                configs: never[];
                configsPrivate: never[];
                configsLocal: never[];
            };
        };
        defaultWorkspace: {
            project: {
                appConfigBase: {};
                builds: {};
                assets: {};
                platformTemplates: {};
            };
            appConfig: {
                configs: never[];
                configsPrivate: never[];
                configsLocal: never[];
            };
        };
        project: {
            appConfigBase: {};
            builds: {};
            assets: {};
            platformTemplates: {};
        };
        appConfig: {
            configs: never[];
            configsPrivate: never[];
            configsLocal: never[];
        };
    };
}>;
export const doResolve: (aPath: any, mandatory?: any, options?: any) => any;
export const doResolvePath: (aPath: any, mandatory?: boolean, options?: {}, fallbackBase?: string) => any;
declare namespace _default {
    export { run };
    export { Config };
}
export default _default;
import * as Constants from "./core/constants";
import * as Common from "./core/common";
import * as Prompt from "./cli/prompt";
import * as EngineManager from "./core/engineManager";
import * as PlatformManager from "./core/platformManager";
import * as SetupManager from "./core/setupManager";
import * as PluginManager from "./core/pluginManager";
import * as ProjectManager from "./core/projectManager";
import * as ConfigManager from "./core/configManager";
import * as SchemaManager from "./core/schemaManager";
import * as SDKManager from "./core/sdkManager";
import * as TemplateManager from "./core/templateManager";
import * as TaskManager from "./core/taskManager";
import * as RuntimeManager from "./core/runtimeManager";
import * as Exec from "./core/systemManager/exec";
import * as FileUtils from "./core/systemManager/fileutils";
import * as ObjectUtils from "./core/systemManager/objectUtils";
import * as Doctor from "./core/systemManager/doctor";
import Config from "./core/configManager/config";
import * as Logger from "./core/systemManager/logger";
import * as NPMUtils from "./core/systemManager/npmUtils";
import * as Resolver from "./core/systemManager/resolve";
import * as Utils from "./core/systemManager/utils";
import { withRNVBabel } from "./core/adapter";
import { withRNVMetro } from "./core/adapter";
export function run(cmd: any, subCmd: any, program: any, process: any): void;
import CLI from "./cli";
import Spinner from "./cli/ora";
export { Constants, Common, Prompt, EngineManager, PlatformManager, SetupManager, PluginManager, ProjectManager, ConfigManager, SchemaManager, SDKManager, TemplateManager, TaskManager, RuntimeManager, Exec, FileUtils, ObjectUtils, Doctor, Config, Logger, NPMUtils, Resolver, Utils, withRNVBabel, withRNVMetro, CLI, Spinner };
//# sourceMappingURL=index.d.ts.map